/* XL֌W */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "timer.h"

#include "skill.h"
#include "map.h"
#include "clif.h"
#include "pc.h"
#include "mob.h"
#include "battle.h"
#include "party.h"
#include "itemdb.h"

#define SKILLUNITTIMER_INVERVAL	100


/* XLԍXe[^Xُԍϊe[u */
int SkillStatusChangeTable[]={	/* skill.henumSC_***Ƃ킹邱 */
/* 0- */
	-1,-1,-1,-1,-1,-1,
	SC_PROVOKE,			/* v{bN */
	-1, 1,-1,
/* 10- */
	SC_SIGHT,			/* TCg */
	-1,-1,-1,-1,
	SC_FREEZE,			/* tXg_Co[ */
	SC_STONE,			/* Xg[J[X */
	-1,-1,-1,
/* 20- */
	-1,-1,-1,-1,
	SC_RUWACH,			/* At */
	-1,-1,-1,-1,
	SC_INCREASEAGI,		/* x */
/* 30- */
	SC_DECREASEAGI,		/* x */
	-1,
	SC_SIGNUMCRUCIS,	/* VOiNVX */
	SC_ANGELUS,			/* GWFX */
	SC_BLESSING,		/* ubVO */
	-1,-1,-1,-1,-1,
/* 40- */
	-1,-1,-1,-1,-1,
	SC_CONCENTRATE,		/* W͌ */
	-1,-1,-1,-1,
/* 50- */
	-1,
	SC_HIDDING,			/* nCfBO */
	-1,-1,-1,-1,-1,-1,-1,-1,
/* 60- */
	SC_TWOHANDQUICKEN,	/* 2HQ */
	-1,-1,-1,-1,-1,
	SC_IMPOSITIO,		/* C|VeBI}kX */
	SC_SUFFRAGIUM,		/* TtME */
	SC_ASPERSIO,		/* AXyVI */
	SC_BENEDICTIO,		/* ̍~ */
/* 70- */
	-1,-1,-1,
	SC_KYRIE,			/* LGGC\ */
	SC_MAGNIFICAT,		/* }OjtBJ[g */
	SC_GLORIA,			/* OA */
	SC_DIVINA,			/* bNXfBr[i */
	-1,
	SC_AETERNA,			/* bNXG[ei */
	-1,
/* 80- */
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
/* 90- */
	-1,-1,
	SC_QUAGMIRE,		/* N@O}CA */
	-1,-1,-1,-1,-1,-1,-1,
/* 100- */
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
/* 110- */
	-1,
	SC_ADRENALINE,		/* AhibV */
	SC_WEAPONPERFECTION,/* EF|p[tFNV */
	SC_OVERTHRUST,		/* I[o[gXg */
	SC_MAXIMIZEPOWER,	/* }LV}CYp[ */
	-1,-1,-1,-1,-1,
/* 120- */
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
/* 130- */
	-1,-1,-1,-1,-1,
	SC_CLOAKING,		/* N[LO */
	SC_STAN,			/* \jbNu[ */
	-1,
	SC_ENCPOISON,		/* G`g|CY */
	SC_POISONREACT,		/* |CYANg */
/* 140- */
	SC_POISON,			/* xm_Xg */
	-1,-1,
	SC_TRICKDEAD,		/* 񂾂ӂ */
	-1,-1,-1,-1,-1,-1,
/* 150- */
	-1,-1,-1,-1,-1,
	SC_LOUD,			/* Eh{CX */
	-1,
	SC_ENERGYCOAT,		/* GiW[R[g */
	-1,-1,
/* 160- */
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
/* 210- */
	-1,-1,-1,-1,-1,
	SC_STRIPWEAPON,
	SC_STRIPSHIELD,
	SC_STRIPARMOR,
	SC_STRIPHELM,
	-1,
/* 220- */
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
/* 230- */
	-1,-1,-1,-1,
	SC_CP_WEAPON,
	SC_CP_SHIELD,
	SC_CP_ARMOR,
	SC_CP_HELM,
	-1,-1,
/* 240- */
	-1,-1,-1,-1,-1,-1,-1,-1,-1,
	SC_AUTOGUARD,
/* 250- */
	-1,
	SC_REFLECTSHIELD,
	-1,-1,-1,
	SC_DEVOTION,
	SC_PROVIDENCE,
	SC_DEFENDER,
	SC_SPEARSQUICKEN,
	-1,
/* 260- */
	-1,-1,-1,-1,-1,-1,-1,-1,
	SC_STEELBODY,
	-1,
/* 270- */
	SC_EXPLOSIONSPIRITS,-1,-1,-1,-1,
	SC_CASTCANCEL,
	-1,
	SC_SPELLBREAKER,
	SC_FREECAST,
	-1,
/* 280- */
	SC_FLAMELAUNCHER,
	SC_FROSTWEAPON,
	SC_LIGHTNINGLOADER,
	SC_SEISMICWEAPON,
	-1,
	SC_VOLCANO,
	SC_DELUGE,
	-1,-1,-1,
/* 290- */
	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
/* 300- */
	-1,-1,-1,-1,-1,-1,-1,-1,-1,
	SC_DRUMBATTLE,
/* 310- */
	-1,-1,-1,
	SC_SIEGFRIED,
	-1,-1,-1,-1,-1,
	SC_WHISTLE,
/* 320- */
	SC_ASSNCROS,
	SC_POEMBRAGI,
	SC_APPLEIDUN,
	-1,-1,-1,-1,-1,-1,
	SC_FORTUNE,
/* 330- */
	SC_SERVICE4U,
	-1,-1,-1,-1,-1,-1,-1,-1,-1,
};

/* XLf[^x[X */
struct skill_db skill_db[MAX_SKILL_DB];

/* ACe쐬f[^x[X */
struct skill_produce_db skill_produce_db[MAX_SKILL_PRODUCE_DB];

/* 쐬XLf[^x[X */
struct skill_arrow_db skill_arrow_db[MAX_SKILL_ARROW_DB];

int skill_get_range( int id ){ return skill_db[id].range; }
int	skill_get_hit( int id ){ return skill_db[id].hit; }
int	skill_get_inf( int id ){ return skill_db[id].inf; }
int	skill_get_pl( int id ){ return skill_db[id].pl; }
int	skill_get_nk( int id ){ return skill_db[id].nk; }
int	skill_get_max( int id ){ return skill_db[id].max; }
int	skill_get_sp( int id ,int lv ){ return skill_db[id].sp[lv-1]; }
int	skill_get_num( int id ,int lv ){ return skill_db[id].num[lv-1]; }
int	skill_get_cast( int id ,int lv ){ return skill_db[id].cast[lv-1]; }
int	skill_get_delay( int id ,int lv ){ return skill_db[id].delay[lv-1]; }
int	skill_get_inf2( int id ){ return skill_db[id].inf2; }


/* vg^Cv */
struct skill_unit_group *skill_unitsetting( struct block_list *src, int skillid,int skilllv,int x,int y,int flag);

/* XLjbgIDԂif[^x[Xɓꂽȁj */
int skill_get_unit_id(int id,int flag)
{
	switch(id){
	case MG_SAFETYWALL:		return 0x7e;				/* ZCteBEH[ */
	case MG_FIREWALL:		return 0x7f;				/* t@CA[EH[ */
	case AL_WARP:			return (flag==0)?0x81:0x80;	/* [v|[^ */
	case PR_BENEDICTIO:		return 0x82;				/* ̍~ */
	case PR_SANCTUARY:		return 0x83;				/* TN`A */
	case PR_MAGNUS:			return 0x84;				/* }OkXGN\VY */
	case AL_PNEUMA:			return 0x85;				/* j[} */
	case WZ_METEOR:			return 0x86;				/* eIXg[ */
	case WZ_VERMILION:		return 0x86;				/* [hIu@[~I */
	case WZ_STORMGUST:		return 0x86;				/* Xg[KXg(Ƃ肠LoVƓŏ) */
	case CR_GRANDCROSS:		return 0x86;				/* OhNX */
	case WZ_FIREPILLAR:		return (flag==0)?0x87:0x88;	/* t@CA[s[ */
	case HT_TALKIEBOX:		return (flag==0)?0x99:0x8c;	/* g[L[{bNX */
	case WZ_ICEWALL:		return 0x8d;				/* ACXEH[ */
	case WZ_QUAGMIRE:		return 0x8e;				/* N@O}CA */
	case HT_BLASTMINE:		return 0x8f;				/* uXg}C */
	case HT_SKIDTRAP:		return 0x90;				/* XLbhgbv */
	case HT_ANKLESNARE:		return 0x91;				/* ANXlA */
	case AS_VENOMDUST:		return 0x92;				/* xm_Xg */
	case HT_LANDMINE:		return 0x93;				/* h}C */
	case HT_SHOCKWAVE:		return 0x94;				/* VbNEF[ugbv */
	case HT_SANDMAN:		return 0x95;				/* Th} */
	case HT_FLASHER:		return 0x96;				/* tbV[ */
	case HT_FREEZINGTRAP:	return 0x97;				/* t[WOgbv */
	case HT_CLAYMORETRAP:	return 0x98;				/* NCA[gbv */
	case SA_DELUGE:			return 0x9b;				/* f[W */
	case BD_LULLABY:		return 0x9e;				/* q */
	case BD_RICHMANKIM:		return 0x9f;				/* jh̉ */
	case BD_ETERNALCHAOS:	return 0xa0;				/* i̍ */
	case BD_DRUMBATTLEFIELD:return 0xa1;					/* 푾ۂ̋ */
	case BD_RINGNIBELUNGEN:	return 0xa2;				/* j[xO̎w */
	case BD_ROKISWEIL:		return 0xa3;				/* L̋ */
	case BD_INTOABYSS:		return 0xa4;				/* [̒ */
	case BD_SIEGFRIED:		return 0xa5;				/* sg̃W[Nt[h */
	case BA_DISSONANCE:		return 0xa6;				/* sa */
	case BA_WHISTLE:		return 0xa7;				/* J */
	case BA_ASSASSINCROSS:	return 0xa8;				/* [z̃ATVNX */
	case BA_POEMBRAGI:		return 0xa9;				/* uM̎ */
	case BA_APPLEIDUN:		return 0xaa;				/* ChD̗ь */
	case DC_UGLYDANCE:		return 0xab;				/* ȃ_X */
	case DC_HUMMING:		return 0xac;				/* n~O */
	case DC_DONTFORGETME:	return 0xad;				/* YȂŁc */
	case DC_FORTUNEKISS:	return 0xae;				/* K^̃LX */
	case DC_SERVICEFORYOU:	return 0xaf;				/* T[rXtH[[ */
	case RG_GRAFFITI:		return 0xb0;				/* OtBeB */
	}
	return 0;
	/*
	0x89,0x8a,0x8b \
	0x9a ̉r݂ȃGtFNg
	0x9b ̉r݂ȃGtFNg
	0x9c ̉r݂ȃGtFNg
	0x9d ȃGtFNg
	*/
}



int skill_check_condition( struct map_session_data *sd );

int skill_castend_damage_id( struct block_list* src, struct block_list *bl,int skillid,int skilllv,unsigned int tick,int flag );


/*==========================================
 * XLǉ
 *------------------------------------------
 */
int skill_additional_effect( struct block_list* src, struct block_list *bl,int skillid,int skilllv,unsigned int tick)
{
	struct map_session_data *sd=NULL;
	struct map_session_data *sd2=NULL;
	int skill,skill2;
	int rate;
	
	if(src->type==BL_PC)
		sd=(struct map_session_data *)src;
	if(bl->type==BL_PC)
		sd2=(struct map_session_data *)bl;

	switch(skillid){
	case 0:					/* ʏU */
		/*  */
		if( sd && pc_isfalcon(sd) && sd->status.weapon == 11 && (skill=pc_checkskill(sd,HT_BLITZBEAT))>0 &&
			rand()%1000 <= sd->paramc[5]*10/3+1 ) {
			int lv=(sd->status.job_level+9)/10;
			skill_castend_damage_id(src,bl,HT_BLITZBEAT,(skill<lv)?skill:lv,tick,0xf00000);
		}
		// Xib`[
		if(sd && (skill=pc_checkskill(sd,RG_SNATCHER)) > 0)
			if((skill*15 + 55) + (skill2 = pc_checkskill(sd,TF_STEAL))*10 > rand()%1000)
				if(pc_steal_item(sd,bl))
					clif_skill_nodamage(src,bl,TF_STEAL,skill2,1);
		break;

	case SM_BASH:			/* obVi}Uj */
		if( sd && (skill=pc_checkskill(sd,SM_FATALBLOW))>0 ){
			if( rand()%100 < 6*(skilllv-5) )
				skill_status_change_start(bl,SC_STAN,skilllv,5000);
		}
		break;

	case TF_POISON:			/* Cxi */
		if(battle_get_elem_type(bl)!=9 && rand()%100< 2*skilllv+10 )
			skill_status_change_start(bl,SC_POISON,skilllv,0);
		break;

	case AS_SONICBLOW:		/* \jbNu[ */
		if( rand()%100 < 2*skilllv+10 )
			skill_status_change_start(bl,SC_STAN,skilllv,5000);
		break;

	case MG_FROSTDIVER:		/* tXg_Co[ */
	case WZ_FROSTNOVA:		/* tXgm@ */
	case WZ_STORMGUST:		/* Xg[KXg */
	case HT_FREEZINGTRAP:	/* t[WOgbv */
	case BA_FROSTJOKE:		/* W[N */
/*
		rate=battle_get_lv(src)/2 +battle_get_int(src)/3+ skilllv*2 +15 -battle_get_mdef(bl);
		if(rate>95)rate=95;
*/
		rate=skilllv*3+35;
		if( rand()%100 < rate )
			skill_status_change_start(bl,SC_FREEZE,skilllv,0);
		break;

	case HT_LANDMINE:		/* h}C */
		if( rand()%100 < 5*skilllv+30 ){
			skill_status_change_start(bl,SC_STAN,skilllv,skilllv*500+1000);
		}
		break;

	case HT_ANKLESNARE:		/* ANXlA */
		{
			int sec=(battle_get_mode(bl)&0x20)?1000:5000;
			skill_status_change_start(bl,SC_ANKLE,skilllv,skilllv*sec);
		}
		break;

	case HT_SANDMAN:		/* Th} */
		if( rand()%100 < 5*skilllv+30 ){
			skill_status_change_start(bl,SC_SLEEP,skilllv,30000);
		}
		break;

	case TF_SPRINKLESAND:	/* ܂ */
		if( rand()%100 < 15 )
			skill_status_change_start(bl,SC_BLIND,1,0);
		break;

	case TF_THROWSTONE:		/* Γ */
		if( rand()%100 < 5 )
			skill_status_change_start(bl,SC_STAN,1,3000);
		break;

	case CR_HOLYCROSS:		/* ܂ */
		if( rand()%100 < 3*skilllv )
			skill_status_change_start(bl,SC_BLIND,1,0);
		break;

	case RG_RAID:		/* TvCYA^bN */
		if( rand()%100 < 10+3*skilllv )
			skill_status_change_start(bl,SC_STAN,1,3000);
		if( rand()%100 < 10+3*skilllv )
			skill_status_change_start(bl,SC_BLIND,1,0);
		break;

#if 0
	case BA_FROSTJOKE:		/* W[N */
		if( rand()%100 < 15+5*skilllv )
			skill_status_change_start(bl,SC_FREEZE,1,0);
		break;
#endif

	/* MOB̒ǉʕtXL */
	case NPC_POISON:
	case NPC_BLINDATTACK:
	case NPC_SILENCEATTACK:
	case NPC_STUNATTACK:
	case NPC_PETRIFYATTACK:
	case NPC_CURSEATTACK:
	case NPC_SLEEPATTACK:
		{
			const int sc[]={
				SC_POISON, SC_BLIND, SC_SILENCE, SC_STAN,
				SC_STONE, SC_CURSE, SC_SLEEP };
			const int sc2[]={
				6000, 6000, 6000, 1000,
				1000, 0, 6000 };
			skill_status_change_start(bl,
				sc[skillid-NPC_POISON],skilllv,sc2[skillid-NPC_POISON]*skilllv);
		}
		break;
	}

	if(sd){	/* J[hɂǉ */
		int i;
		for(i=SC_STONE;i<=SC_BLIND;i++){
			if( sd->addeff[i-SC_STONE]>0 && rand()%100<sd->addeff[i-SC_STONE] ){
				printf("PC %d skill_addeff: cardɂُ픭 %d %d\n",sd->bl.id,i,sd->addeff[i-SC_STONE]);
				skill_status_change_start(bl,i,1,5);
			}
		}
	}

	return 0;
}

/*=========================================================================
 XLU΂
-------------------------------------------------------------------------*/
int skill_blown( struct block_list *src, struct block_list *target,int count)
{
	static const int dirx[8]={0,-1,-1,-1,0,1,1,1};
	static const int diry[8]={1,1,0,-1,-1,-1,0,1};
	int dx=0,dy=0,nx,ny;
	int x=target->x,y=target->y;
	int ret;
	int moveblock;
	struct map_session_data *sd=NULL;
	struct mob_data *md=NULL;
	
	if(target->type==BL_PC)
		sd=(struct map_session_data *)target;
	else if(target->type==BL_MOB)
		md=(struct mob_data *)target;

	if(!(count&0x10000 && (sd||md))){	/* wȂȂʒu֌W߂ */
		dx=target->x-src->x; dx=(dx>0)?1:((dx<0)?-1: 0);
		dy=target->y-src->y; dy=(dy>0)?1:((dy<0)?-1: 0);
	}
	if(dx==0 && dy==0){
		int dir=(sd)?sd->dir:md->dir;
		if(dir>=0 && dir<8){
			dx=-dirx[dir];
			dy=-diry[dir];
		}
	}

	ret=path_blownpos(target->m,x,y,dx,dy,count&0xffff);
	nx=ret>>16;
	ny=ret&0xffff;
	moveblock=( x/BLOCK_SIZE != nx/BLOCK_SIZE || y/BLOCK_SIZE != ny/BLOCK_SIZE);

	if(count&0x20000) {
		if(sd){
			sd->to_x=nx;
			sd->to_y=ny;
			if(sd->walktimer != -1)
				pc_stop_walking(sd,1);
			sd->walktimer = 1;
			clif_walkok(sd);
			clif_movechar(sd);
		}
		else if(md) {
			md->to_x=nx;
			md->to_y=ny;
			if(md->state.state == MS_WALK)
				mob_stop_walking(md,1);
			md->state.state = MS_WALK;
			clif_fixmobpos(md);
		}
	}

	dx = nx - x;
	dy = ny - y;

	if(sd)	/* ʊOɏôŏ */
		map_foreachinmovearea(clif_pcoutsight,
			target->m,x-AREA_SIZE,y-AREA_SIZE,
			x+AREA_SIZE,y+AREA_SIZE,dx,dy,0,sd);
	if(md)
		map_foreachinmovearea(clif_moboutsight,
			target->m,x-AREA_SIZE,y-AREA_SIZE,
			x+AREA_SIZE,y+AREA_SIZE,dx,dy,BL_PC,md);

	if(moveblock) map_delblock(target);
	target->x=nx;
	target->y=ny;
	if(moveblock) map_addblock(target);


	skill_unit_move(target,gettick(),(count&0xffff)+5);	/* XLjbg̔ */

	if(sd) {	/* ʓɓĂ̂ŕ\ */
		map_foreachinmovearea(clif_pcinsight,
			target->m,nx-AREA_SIZE,ny-AREA_SIZE,
			nx+AREA_SIZE,ny+AREA_SIZE,-dx,-dy,0,sd);
		if(count&0x20000)
			sd->walktimer = -1;
	}
	if(md) {
		map_foreachinmovearea(clif_mobinsight,
			target->m,nx-AREA_SIZE,ny-AREA_SIZE,
			nx+AREA_SIZE,ny+AREA_SIZE,-dx,-dy,BL_PC,md);
		if(count&0x20000)
			md->state.state = MS_IDLE;
	}

	return 0;
}


/*
 * =========================================================================
 * XLUʏ܂Ƃ
 * flag̐B16i}
 * 	00XRTTff
 *  ff	= magicŌvZɓnj
 *	TT	= pPbgtype(0ŃftHgj
 *  X   = pPbg̃XLLv
 *  R	= \iskill_area_subŎgpj
 *-------------------------------------------------------------------------
 */
int skill_attack( int attack_type, struct block_list* src, struct block_list *dsrc,
	 struct block_list *bl,int skillid,int skilllv,unsigned int tick,int flag )
{
	struct Damage dmg;
	int type,lv;

	if(src == NULL || dsrc == NULL || bl == NULL)
		return 0;
	if(src->prev == NULL || dsrc->prev == NULL || bl->prev == NULL)
		return 0;
	if(src->type == BL_PC && pc_isdead((struct map_session_data *)src))
		return 0;
	if(dsrc->type == BL_PC && pc_isdead((struct map_session_data *)dsrc))
		return 0;
	if(bl->type == BL_PC && pc_isdead((struct map_session_data *)bl))
		return 0;

	type=-1;
	lv=(flag>>20)&0xf;
	dmg=battle_calc_attack(attack_type, src,bl, skillid,skilllv, flag&0xff );
	
	if(lv==15)lv=-1;

	if( flag&0xff00 )
		type=(flag&0xff00)>>8;

	if(dmg.damage <= 0 || dmg.damage < dmg.div_)
		dmg.blewcount = 0;

	if( dmg.blewcount ){	/* ΂Ƃ̃pPbg */
		skill_blown(dsrc,bl,dmg.blewcount);
		clif_skill_damage2(dsrc,bl,tick,dmg.amotion,dmg.dmotion,
			dmg.damage, dmg.div_, skillid, (lv!=0)?lv:skilllv, type );
	} else			/* XL̃_[WpPbg */
		clif_skill_damage(dsrc,bl,tick,dmg.amotion,dmg.dmotion,
			dmg.damage, dmg.div_, skillid, (lv!=0)?lv:skilllv, type );

	map_freeblock_lock();
	/* ۂɃ_[Ws */
	battle_damage(src,bl,(dmg.damage+dmg.damage2));
	/* _[WȂǉʔ */
	if((dmg.damage+dmg.damage2)>0)
		skill_additional_effect(src,bl,skillid,skilllv,tick);

	map_freeblock_unlock();

	if(bl->type==BL_MOB && src!=bl)	/* XLgpMOBXL */
		mobskill_use((struct mob_data *)bl,tick,MSC_SKILLUSED|(skillid<<16));

	return (dmg.damage+dmg.damage2);	/* ^_Ԃ */
}


/*==========================================
 * XL͈͍Up(map_foreachinareaĂ΂)
 * flagɂāF16i}mF
 * MSB <- 00fTffff ->LSB
 *	T	=^[QbgIp(BCT_*)
 *  ffff=RɎgp\
 *  0	=\B0ɌŒ
 *------------------------------------------
 */
static int skill_area_temp[8];	/* ꎞϐBKvȂgB */
typedef int (*SkillFunc)(struct block_list *,struct block_list *,int,int,unsigned int,int);
int skill_area_sub( struct block_list *bl,va_list ap )
{
	struct block_list *src;
	int skill_id,skill_lv,flag;
	unsigned int tick;
	SkillFunc func;
	
	if(bl->type!=BL_PC && bl->type!=BL_MOB)
		return 0;

	src=va_arg(ap,struct block_list *);
	skill_id=va_arg(ap,int);
	skill_lv=va_arg(ap,int);
	tick=va_arg(ap,unsigned int);
	flag=va_arg(ap,int);
	func=va_arg(ap,SkillFunc);

	if(battle_check_target(src,bl,flag) > 0)
		func(src,bl,skill_id,skill_lv,tick,flag);
	return 0;
}
/*=========================================================================
 * ͈̓XLgp
 */
/* Ώۂ̐JEgBiskill_area_temp[0]ĂƁj */
int skill_area_sub_count(struct block_list *src,struct block_list *target,int skillid,int skilllv,unsigned int tick,int flag)
{
	if(skill_area_temp[0] < 0xff)
		skill_area_temp[0]++;
	return 0;
}

/*==========================================
 *
 *------------------------------------------
 */
static int skill_timerskill(int tid, unsigned int tick, int id,int data )
{
	struct map_session_data *sd = NULL;
	struct mob_data *md = NULL;
	struct block_list *src,*target;
	struct skill_timerskill *skl = NULL;
	
	src = map_id2bl(id);
	if(src == NULL || src->prev == NULL)
		return 0;

	if(src->type == BL_PC) {
		sd = (struct map_session_data *)src;
		skl = &sd->skilltimerskill[data];
	}
	else if(src->type == BL_MOB) {
		md = (struct mob_data *)src;
		skl = &md->skilltimerskill[data];
	}
	else
		return 0;

	skl->timer = -1;
	if(skl->target_id) {
		target = map_id2bl(skl->target_id);
		if(target == NULL || target->prev ==NULL)
			return 0;
		if(src->m != target->m)
			return 0;
		if(sd && pc_isdead(sd))
			return 0;
		if(target->type == BL_PC && pc_isdead((struct map_session_data *)target))
			return 0;

		switch(skl->skill_id) {
			case TF_BACKSLIDING:	
				clif_skill_nodamage(src,src,skl->skill_id,skl->skill_lv,1);
				break;
			default:
				skill_attack(skl->type,src,src,target,skl->skill_id,skl->skill_lv,tick,skl->flag);
				break;
		}
	}
	else {
		if(src->m != skl->map)
			return 0;
		switch(skl->skill_id) {
			case WZ_METEOR:
				if(skl->type >= 0) {
					skill_unitsetting(src,skl->skill_id,skl->skill_lv,skl->type>>16,skl->type&0xFFFF,0);
					clif_skill_poseffect(src,skl->skill_id,skl->skill_lv,skl->x,skl->y,tick);
				}
				else
					skill_unitsetting(src,skl->skill_id,skl->skill_lv,skl->x,skl->y,0);
				break;
		}
	}

	return 0;
}

/*==========================================
 *
 *------------------------------------------
 */
int skill_addtimerskill(struct block_list *src,int tick,int target,int x,int y,int skill_id,int skill_lv,int type,int flag)
{
	int i;

	if(src->type == BL_PC) {
		struct map_session_data *sd = (struct map_session_data *)src;
		for(i=0;i<MAX_SKILLTIMERSKILL;i++) {
			if(sd->skilltimerskill[i].timer == -1) {
				sd->skilltimerskill[i].timer = add_timer(tick, skill_timerskill, src->id, i);
				sd->skilltimerskill[i].src_id = src->id;
				sd->skilltimerskill[i].target_id = target;
				sd->skilltimerskill[i].skill_id = skill_id;
				sd->skilltimerskill[i].skill_lv = skill_lv;
				sd->skilltimerskill[i].map = src->m;
				sd->skilltimerskill[i].x = x;
				sd->skilltimerskill[i].y = y;
				sd->skilltimerskill[i].type = type;
				sd->skilltimerskill[i].flag = flag;

				return 0;
			}
		}
		return 1;
	}
	else if(src->type == BL_MOB) {
		struct mob_data *md = (struct mob_data *)src;
		for(i=0;i<MAX_SKILLTIMERSKILL/2;i++) {
			if(md->skilltimerskill[i].timer == -1) {
				md->skilltimerskill[i].timer = add_timer(tick, skill_timerskill, src->id, i);
				md->skilltimerskill[i].src_id = src->id;
				md->skilltimerskill[i].target_id = target;
				md->skilltimerskill[i].skill_id = skill_id;
				md->skilltimerskill[i].skill_lv = skill_lv;
				md->skilltimerskill[i].map = src->m;
				md->skilltimerskill[i].x = x;
				md->skilltimerskill[i].y = y;
				md->skilltimerskill[i].type = type;
				md->skilltimerskill[i].flag = flag;

				return 0;
			}
		}
		return 1;
	}

	return 1;
}

/*==========================================
 *
 *------------------------------------------
 */
int skill_cleartimerskill(struct block_list *src)
{
	int i;

	if(src->type == BL_PC) {
		struct map_session_data *sd = (struct map_session_data *)src;
		for(i=0;i<MAX_SKILLTIMERSKILL;i++) {
			if(sd->skilltimerskill[i].timer != -1) {
				delete_timer(sd->skilltimerskill[i].timer, skill_timerskill);
				sd->skilltimerskill[i].timer = -1;
			}
		}
	}
	else if(src->type == BL_MOB) {
		struct mob_data *md = (struct mob_data *)src;
		for(i=0;i<MAX_SKILLTIMERSKILL/2;i++) {
			if(md->skilltimerskill[i].timer != -1) {
				delete_timer(md->skilltimerskill[i].timer, skill_timerskill);
				md->skilltimerskill[i].timer = -1;
			}
		}
	}

	return 0;
}

/* ͈̓XLgp܂
 * -------------------------------------------------------------------------
 */


/*==========================================
 * XLgpirAIDwUnj
 * iXpQbeBɌĂPOiI(_|)j
 *------------------------------------------
 */
int skill_castend_damage_id( struct block_list* src, struct block_list *bl,int skillid,int skilllv,unsigned int tick,int flag )
{
	struct map_session_data *sd=NULL;
	int i;

	if(src->type==BL_PC)
		sd=(struct map_session_data *)src;
	if(sd && pc_isdead(sd))
		return 0;

	if(bl == NULL || bl->prev == NULL)
		return 0;
	if(bl->type == BL_PC && pc_isdead((struct map_session_data *)bl))
		return 0;

	switch(skillid)
	{
	/* UnXL */
	case SM_BASH:			/* obV */
	case MC_MAMMONITE:		/* }[iCg */
	case AC_DOUBLE:			/* _uXgCtBO */
	case AS_SONICBLOW:		/* \jbNu[ */
	case KN_PIERCE:			/* sA[X */
	case KN_SPEARBOOMERANG:	/* XsAu[ */
	case TF_POISON:			/* Cxi */
	case TF_SPRINKLESAND:	/* ܂ */
	case AC_CHARGEARROW:	/* `[WA[ */
	case KN_SPEARSTAB:		/* XsAX^u */
	case RG_BACKSTAP:		/* obNX^u */
	case RG_RAID:		/* TvCYA^bN */
	case RG_INTIMIDATE:		/* CeB~fCg */
	case BA_MUSICALSTRIKE:	/* ~[WJXgCN */
	case DC_THROWARROW:		/*  */
	case BA_DISSONANCE:		/* sa */
	case MO_INVESTIGATE:	/*  */
	case CR_HOLYCROSS:		/* z[[NX */
	/* ȉMOBp */
	/* P̍UASPUAUAh䖳UAiU */
	case NPC_PIERCINGATT:
	case NPC_MENTALBREAKER:
	case NPC_RANGEATTACK:
	case NPC_CRITICALSLASH:
	case NPC_COMBOATTACK:
	/* KUAōUAÍUAٍUAX^U */
	case NPC_GUIDEDATTACK:
	case NPC_POISON:
	case NPC_BLINDATTACK:
	case NPC_SILENCEATTACK:
	case NPC_STUNATTACK:
	/* ΉUA􂢍UAUA_ATKU */
	case NPC_PETRIFYATTACK:
	case NPC_CURSEATTACK:
	case NPC_SLEEPATTACK:
	case NPC_RANDOMATTACK:
	/* UAnUAΑUAU */
	case NPC_WATERATTACK:
	case NPC_GROUNDATTACK:
	case NPC_FIREATTACK:
	case NPC_WINDATTACK:
	/* őUAUAőUAOUASPU */
	case NPC_POISONATTACK:
	case NPC_HOLYATTACK:
	case NPC_DARKNESSATTACK:
	case NPC_TELEKINESISATTACK:
	case NPC_LICK:
		if(skillid==RG_BACKSTAP && pc_ishiding(sd))
			skill_status_change_end(src, SC_HIDDING, -1);	// nCfBO
		skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag);
		break;
	case MO_FINGEROFFENSIVE:	/* we */
		if(!battle_config.finger_offensive_type)
			skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag);
		else {
			skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag);
			if(sd) {
				for(i=1;i<sd->spiritball_old;i++)
					skill_addtimerskill(src,tick+i*200,bl->id,0,0,skillid,skilllv,BF_WEAPON,flag);
				sd->canmove_tick = tick + (sd->spiritball_old-1)*200;
			}
		}
		break;
	case MO_CHAINCOMBO:		/* Aŏ */
		sd->combo_delay1 = 1000 - 4 * battle_get_agi(src) - 2 *  battle_get_dex(src);
		if (sd->combo_delay1 < sd->aspd*2)
			sd->combo_delay1 = sd->aspd*2;
		sd->combo_flag = 1;
		if (pc_checkskill(sd, MO_COMBOFINISH))
			sd->combo_delay1 += 300;
		clif_status_change(src, 0x59, 1);
		sd->canmove_tick = tick + sd->combo_delay1;
		clif_combo_delay(src, sd->combo_delay1);
		skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag);
		sd->combo_delay2 = tick + sd->combo_delay1 - 300;
		break;
	case MO_COMBOFINISH:	/* җ */
		sd->combo_delay2 = 700 - 4 * battle_get_agi(src) - 2 *  battle_get_dex(src);
		if (sd->combo_delay2 < sd->aspd*2)
			sd->combo_delay2 = sd->aspd*2;
		sd->combo_flag = 3;
		if (pc_checkskill(sd, MO_EXTREMITYFIST))
			sd->combo_delay2 += 300;
		clif_status_change(src, 0x59, 1);
		sd->canmove_tick = tick + sd->combo_delay2;
		clif_combo_delay(src, sd->combo_delay2);
		skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag);
		sd->combo_delay3 = tick + sd->combo_delay2 - 300;
		break;
	case MO_EXTREMITYFIST:	/* CeP */
	{
		int dx,dy;
		skill_status_change_end(src, SC_EXPLOSIONSPIRITS, -1);
		dx = ((sd->bl.x - bl->x)>0?-4:4);
		dy = ((sd->bl.y - bl->y)>0?-4:4);
		dx = ((sd->bl.x - bl->x)!=0?dx:0);
		dy = ((sd->bl.y - bl->y)!=0?dy:0);
		sd->bl.x = bl->x;
		sd->bl.y = bl->y;
		while(!pc_can_reach(sd, sd->bl.x + dx, sd->bl.y + dy)) {
			dx = (int)((float)dx / 4 * 3);
			dy = (int)((float)dy / 4 * 3);
			if(dx == 0 && dy == 0) break;
		}
		sd->to_x = sd->bl.x + dx;
		sd->to_y = sd->bl.y + dy;
		sd->canact_tick = tick + skill_get_delay(skillid, skilllv);
		sd->canmove_tick = tick + skill_get_delay(skillid, skilllv);
		skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,flag);
		pc_walktoxy(sd, sd->to_x, sd->to_y);
		break;
	}
	/* n͈͍UXL */
	case AC_SHOWER:			/* A[V[ */
	case SM_MAGNUM:			/* }OiuCN */
	case AS_GRIMTOOTH:		/* OgD[X */
	case KN_BOWLINGBASH:	/* {EOobV */
	case MC_CARTREVOLUTION:	/* J[gH[V */
	case NPC_SPLASHATTACK:	/* XvbVA^bN */
		if(flag&3){
			/* ʂɃ_[W^ */
			if(bl->id!=skill_area_temp[1]){
				int dist=0;
				if(skillid==SM_MAGNUM){	/* }OiuCNȂ璆S̋vZ */
					int dx=abs( bl->x - skill_area_temp[2] );
					int dy=abs( bl->y - skill_area_temp[3] );
					dist=((dx>dy)?dx:dy);
				}
				skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,
					0x0500|dist  );
			}
		}else{
			int ar=1;
			int x=bl->x,y=bl->y;
			if( skillid==SM_MAGNUM ){
				x=src->x;
				y=src->y;
			}else if(skillid==NPC_SPLASHATTACK)	/* XvbVA^bN͔͈7*7 */
				ar=3;
			else if(skillid==KN_BOWLINGBASH){/*{EOobVĂ݂i΂͂łj */
				int i;	/* l畷Ȃ̂ŊԈĂ\偕 */
				for(i=0;i<4;i++){
					skill_blown(src,bl,1|0x20000);
					skill_area_temp[0]=0;
					map_foreachinarea(skill_area_sub,
						bl->m,bl->x-1,bl->y-1,bl->x+1,bl->y+1,0,
						src,skillid,skilllv,tick, flag|BCT_ENEMY ,
						skill_area_sub_count);
					if(skill_area_temp[0]>1)break;
				}
			/*	if(i==4)break; */
				x=bl->x;y=bl->y;
			}
			skill_area_temp[1]=bl->id;
			skill_area_temp[2]=x;
			skill_area_temp[3]=y;
			/* ܂^[QbgɍU */
			skill_attack(BF_WEAPON,src,src,bl,skillid,skilllv,tick,0);
			/* ̌^[QbgȊO͈͓̔̓GŜɏs */
			map_foreachinarea(skill_area_sub,
				bl->m,x-ar,y-ar,x+ar,y+ar,0,
				src,skillid,skilllv,tick, flag|BCT_ENEMY|1,
				skill_castend_damage_id);
		}
		break;

	/* @nXL */
	case MG_SOULSTRIKE:			/* \EXgCN */
	case MG_COLDBOLT:			/* R[h{g */
	case MG_FIREBOLT:			/* t@CA[{g */
	case MG_LIGHTNINGBOLT:		/* CgjO{g */
	case WZ_EARTHSPIKE:			/* A[XXpCN */
	case AL_HEAL:				/* q[ */
	case AL_HOLYLIGHT:			/* z[[Cg */
	case ALL_RESURRECTION:		/* UNV */
	case PR_TURNUNDEAD:			/* ^[Afbh */
	case MG_FROSTDIVER:			/* tXg_Co[ */
	case WZ_JUPITEL:			/* seT_[ */
	case NPC_MAGICALATTACK:		/* MOB:@ŌU */
		skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
		break;

	case WZ_WATERBALL:			/* EH[^[{[ */
		skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
		if(skilllv>1)
			skill_status_change_start(src,SC_WATERBALL,skilllv,bl->id);
		break;

	case PR_BENEDICTIO:			/* ̍~ */
		if(battle_get_race(bl)==1 || battle_get_race(bl)==6)
			skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,flag);
		break;

	/* @n͈͍UXL */
	case MG_NAPALMBEAT:			/* ip[r[g */
	case MG_FIREBALL:			/* t@C[{[ */
	case MG_THUNDERSTORM:		/* T_[Xg[(flag=2̂) */
	case WZ_HEAVENDRIVE:		/* wuYhCu(flag=2̂) */
		if(flag&3){
			/* ʂɃ_[W^ */
			if(bl->id!=skill_area_temp[1]){
				if(skillid==MG_FIREBALL){	/* t@C[{[Ȃ璆S̋vZ */
					int dx=abs( bl->x - skill_area_temp[2] );
					int dy=abs( bl->y - skill_area_temp[3] );
					skill_area_temp[0]=((dx>dy)?dx:dy);
				}
				skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,
					skill_area_temp[0]| ((flag&2)?0:0x0500)  );
			}
		}else{
			int ar=(skillid==MG_NAPALMBEAT)?1:2;
			skill_area_temp[1]=bl->id;
			if(skillid==MG_NAPALMBEAT){	/* ip[ł͐ɐ */
				skill_area_temp[0]=0;
				map_foreachinarea(skill_area_sub,
					bl->m,bl->x-1,bl->y-1,bl->x+1,bl->y+1,0,
					src,skillid,skilllv,tick, flag|BCT_ENEMY ,
					skill_area_sub_count);
			}else{
				skill_area_temp[2]=bl->x;
				skill_area_temp[3]=bl->y;
			}
			/* ܂^[QbgɍU */
			skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,
					skill_area_temp[0] );
			/* ̌^[QbgȊO͈͓̔̓GŜɏs */
			map_foreachinarea(skill_area_sub,
				bl->m,bl->x-ar,bl->y-ar,bl->x+ar,bl->y+ar,0,
				src,skillid,skilllv,tick, flag|BCT_ENEMY|1,
				skill_castend_damage_id);
			break;
		}
		break;

	case WZ_FROSTNOVA:			/* tXgm@ */
		/* ʂɃ_[W^ */
		if(bl->id!=skill_area_temp[1] &&
			(bl->x!=skill_area_temp[2] || bl->y!=skill_area_temp[3]) )
			skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick,0 );
		break;


	/* ̑ */
	case HT_BLITZBEAT:			/* ubcr[g */
		if(flag&1){
			/* ʂɃ_[W^ */
			if(bl->id!=skill_area_temp[1])
				skill_attack(BF_MISC,src,src,bl,skillid,skilllv,tick,skill_area_temp[0]|(flag&0xf00000));
		}else{
			skill_area_temp[0]=0;
			skill_area_temp[1]=bl->id;
			if(flag&0xf00000)
				map_foreachinarea(skill_area_sub,bl->m,bl->x-1,bl->y-1,bl->x+1,bl->y+1,0,
					src,skillid,skilllv,tick, flag|BCT_ENEMY ,skill_area_sub_count);
			/* ܂^[QbgɍU */
			skill_attack(BF_MISC,src,src,bl,skillid,skilllv,tick,skill_area_temp[0]|(flag&0xf00000));
			/* ̌^[QbgȊO͈͓̔̓GŜɏs */
			map_foreachinarea(skill_area_sub,
				bl->m,bl->x-1,bl->y-1,bl->x+1,bl->y+1,0,
				src,skillid,skilllv,tick, flag|BCT_ENEMY|1,
				skill_castend_damage_id);
			break;
		}
		break;

	case TF_THROWSTONE:			/* Γ */
	case NPC_SMOKING:			/* X[LO */
		skill_attack(BF_MISC,src,src,bl,skillid,skilllv,tick,0 );
		break;

	case NPC_SELFDESTRUCTION:	/*  */
		if(flag&1){
			/* ʂɃ_[W^ */
			if(src->type==BL_MOB){
				struct mob_data *md=(struct mob_data *)src;
				md->hp=skill_area_temp[0];
				if(bl->id!=skill_area_temp[1])
					skill_attack(BF_MISC,src,src,bl,skillid,skilllv,tick,flag );
				md->hp=1;
			}
		}else{
			skill_area_temp[0]=battle_get_hp(src);
			skill_area_temp[1]=bl->id;
			/* ܂^[QbgɍU */
			skill_attack(BF_MISC,src,src,bl,skillid,skilllv,tick,flag );
			/* ̌^[QbgȊO͈͓̔̓GŜɏs */
			map_foreachinarea(skill_area_sub,
				bl->m,bl->x-5,bl->y-5,bl->x+5,bl->y+5,0,
				src,skillid,skilllv,tick, flag|BCT_ALL|1,
				skill_castend_damage_id);
			battle_damage(src,src,1);
			break;
		}
		break;

	case AC_MAKINGARROW:			/* 쐬 */
		if(sd!=NULL)
			clif_arrow_create_list(sd);
		break;

	/* HPz/HPz@ */
	case NPC_BLOODDRAIN:
	case NPC_ENERGYDRAIN:
		battle_heal(NULL,src,
			skill_attack( (skillid==NPC_BLOODDRAIN)?BF_WEAPON:BF_MAGIC,
				src,src,bl,skillid,skilllv,tick,flag), 0 );
		break;
	}

	return 0;
}



/*==========================================
 * XLgpirAIDwxnj
 *------------------------------------------
 */
int skill_castend_nodamage_id( struct block_list *src, struct block_list *bl,int skillid,int skilllv,unsigned int tick,int flag )
{
	struct map_session_data *sd=NULL;
	struct map_session_data *dstsd=NULL;
	struct mob_data *md=NULL;
	int i;

	if(src->type==BL_PC)
		sd=(struct map_session_data *)src;
	else if(src->type==BL_MOB)
		md=(struct mob_data *)src;

	if(bl->type==BL_PC)
		dstsd=(struct map_session_data *)bl; 

	if(bl == NULL || bl->prev == NULL)
		return 0;
	if(sd && pc_isdead(sd))
		return 0;
	if(dstsd && pc_isdead(dstsd) && skillid != ALL_RESURRECTION)
		return 0;

	switch(skillid)
	{
#if 0
	case SM_RECOVERY:			/* SP񕜌 */
		{
        int a=0,i,bonus,c=0;
		bonus=100+(skilllv*10);
        if(skilllv==1){a=500 > 550;}
        else if(skilllv==2){a=500 > 551;}
        else if(skilllv==3){a=500 > 551;}
        else if(skilllv==4){a=500 > 551;}
		else if(skilllv==5){a=500 > 551;}
		else if(skilllv==6){a=500 > 551;}
		else if(skilllv==7){a=500 > 551;}
		else if(skilllv==8){a=500 > 551;}
		else if(skilllv==9){a=500 > 551;}
        else if(skilllv==10){a=500 > 551;}
        if(a>0){
           for(i=0;i<MAX_INVENTORY;i++){
          if(sd->status.inventory[i].nameid==a){
                 pc_delitem(sd,i,1,0);
                 c=1;
                 if(skilllv==1){a=rand()%15+30;}
                 else if(skilllv==2){a=rand()%20+70;}
                 else if(skilllv==3){a=rand()%60+175;}
                 else if(skilllv==4){a=rand()%80+350;}
                 else if(skilllv==5){a=rand()%80+350;}
				 else if(skilllv==6){a=rand()%80+350;}
				 else if(skilllv==7){a=rand()%80+350;}
				 else if(skilllv==8){a=rand()%80+350;}
				 else if(skilllv==9){a=rand()%80+350;}
				 else if(skilllv==10){a=rand()%80+350;}
                 if(a>1){
                    clif_skill_nodamage(src,bl,skillid,(bonus*a)/100,1);
                    battle_heal(NULL,bl,(bonus*a)/100,0);
                 }
          }
       }
       if(c==0){clif_displaymessage(sd->fd,"Potions.");}
#endif

	case AL_HEAL:				/* q[ */
		{
			int heal=skill_calc_heal( src, skilllv );
			int heal_get_jobexp;
			if( bl->type==BL_PC &&
				pc_check_equip_dcard((struct map_session_data *)bl,4128) )
				heal=0;	/* 峃J[hiq[ʂOj */
			clif_skill_nodamage(src,bl,skillid,heal,1);
			heal_get_jobexp = battle_heal(NULL,bl,heal,0);
			
			// JOBoll
			if(src->type == BL_PC && bl->type==BL_PC && heal > 0 && src != bl){
				heal_get_jobexp = heal_get_jobexp * battle_config.heal_exp / 100;
				if(heal_get_jobexp <= 0)
					heal_get_jobexp = 1;
				pc_gainexp((struct map_session_data *)src,0,heal_get_jobexp);
			}
		}
		break;

	case ALL_RESURRECTION:		/* UNV */
		if(bl->type==BL_PC){
			int per=0;
			struct map_session_data *tsd=(struct map_session_data*)bl;

			if( (map[bl->m].flag.pvp) && tsd->pvp_point<=0 )
				break;			/* PVPŕs\ */

			if(pc_isdead(tsd)){	/* S */
				clif_skill_nodamage(src,bl,skillid,skilllv,1);
				switch(skilllv){
				case 2: per=15; break;
				case 3: per=30; break;
				case 4: per=50; break;
				}
				tsd->status.hp=tsd->status.max_hp*per/100;
				if(tsd->status.hp<=0) tsd->status.hp=1;
				if( pc_check_equip_dcard(tsd,4144) ){	/* IVXJ[h */
					tsd->status.hp=tsd->status.max_hp;
					tsd->status.sp=tsd->status.max_sp;
				}
				pc_setstand(tsd);
				if(battle_config.ghost_time > 0)
					pc_setghosttimer(tsd,battle_config.ghost_time);
				clif_updatestatus(tsd,SP_HP);
				clif_resurrection(&tsd->bl,1);
			}
		}
		break;

	case AL_INCAGI:			/* x */
	case AL_DECAGI:			/* x */
	case AL_BLESSING:		/* ubVO */
	case KN_TWOHANDQUICKEN:	/* c[nhNCbP */
	case CR_SPEARQUICKEN:	/* XsANCbP */
	case PR_IMPOSITIO:		/* C|VeBI}kX */
	case PR_ASPERSIO:		/* AXyVI */
	case PR_KYRIE:			/* LGGC\ */
	case PR_LEXDIVINA:		/* bNXfBr[i */
	case PR_LEXAETERNA:		/* bNXG[ei */
	case AS_ENCHANTPOISON:	/* G`g|CY */
	case AS_POISONREACT:	/* |CYANg */
	case AC_CONCENTRATION:	/* W͌ */
	case MC_LOUD:			/* Eh{CX */
	case MG_ENERGYCOAT:		/* GiW[R[g */
	case SM_PROVOKE:		/* v{bN */
	case SM_ENDURE:			/* CfA */
	case PR_SUFFRAGIUM:		/* TtME */
	case MG_SIGHT:			/* TCg */
	case AL_RUWACH:			/* At */
	case PR_BENEDICTIO:		/* ̍~ */
	case CR_PROVIDENCE:		/* vBfX */
	case SA_FLAMELAUNCHER:	/* tC`[ */
	case SA_FROSTWEAPON:	/* tXgEF| */
	case SA_LIGHTNINGLOADER:/* CgjO[_[ */
	case SA_SEISMICWEAPON:	/* TCY~bNEF| */
	case MO_EXPLOSIONSPIRITS:	// g
	case MO_STEELBODY:		// 
#if 0
	case CR_AUTOGUARD:		/* I[gK[h */
	case CR_DEFENDER:		/* fBtF_[ */
	case SA_CASTCANCEL:		/* LXgLZ */
	case SA_FREECAST:		/* t[LXg */
	case SA_VOLCANO:		/* {P[m */
	case SA_DELUGE:			/* f[W */
	case SA_VIOLENTGALE:	/* oCIgQC */
	case SA_LANDPROTECTOR:	/* hveN^[ */
	case BA_FROSTJOKE:		/* W[N */
#endif
		clif_skill_nodamage( (skillid==PR_KYRIE)?bl:src,bl,skillid,skilllv,1);
		skill_status_change_start( bl,
			SkillStatusChangeTable[skillid], skilllv, 0 );
		if(skillid==SM_PROVOKE && bl->type==BL_MOB)
			mob_target((struct mob_data *)bl,src,skill_get_range(skillid));
		break;
	case MO_CALLSPIRITS:	// C
		if(sd) {
			clif_skill_nodamage(src,bl,skillid,skilllv,1);
			pc_addspiritball(sd,60*10*1000,skilllv);
		}
		break;
	case MO_ABSORBSPIRITS:	// CD
		if(sd && dstsd) {
			if(sd == dstsd || map[sd->bl.m].flag.pvp || map[sd->bl.m].flag.gvg) {
				if(dstsd->spiritball > 0) {
					clif_skill_nodamage(src,bl,skillid,skilllv,1);
					i = dstsd->spiritball * 7;
					pc_delspiritball(dstsd,dstsd->spiritball,0);
					if(i > 0x7FFF)
						i = 0x7FFF;
					if(sd->status.sp + i > sd->status.max_sp) {
						i = sd->status.max_sp - sd->status.sp;
						sd->status.sp = sd->status.max_sp;
					}
					else
						sd->status.sp += i;
					clif_heal(sd->fd,SP_SP,i);
				}
				else
					clif_skill_nodamage(src,bl,skillid,skilllv,0);
			}
			else
				clif_skill_nodamage(src,bl,skillid,skilllv,0);
		}
		break;

	case BS_HAMMERFALL:		/* n}[tH[ */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		if( rand()%100 < (20+ 10*skilllv) ) {
			skill_status_change_start(bl,SC_STAN,skilllv,10000);
		}
		break;

	case RG_RAID:			/* TvCYA^bN */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		{
			int x=bl->x,y=bl->y;
			skill_area_temp[1]=bl->id;
			skill_area_temp[2]=x;
			skill_area_temp[3]=y;
			map_foreachinarea(skill_area_sub,
				bl->m,x-1,y-1,x+1,y+1,0,
				src,skillid,skilllv,tick, flag|BCT_ENEMY|1,
				skill_castend_damage_id);
		}
		skill_status_change_end(src, SC_HIDDING, -1);	// nCfBO
		break;

	/* p[eBXL */
	case AL_ANGELUS:		/* GWFX */
	case PR_MAGNIFICAT:		/* }OjtBJ[g */
	case PR_GLORIA:			/* OA */
	case BS_ADRENALINE:		/* AhibV */
	case BS_WEAPONPERFECT:	/* EF|p[tFNV */
	case BS_OVERTHRUST:		/* I[o[gXg */
		if( sd==NULL || sd->status.party_id==0 || (flag&1) ){
			/* ʂ̏ */
			clif_skill_nodamage(bl,bl,skillid,skilllv,1);
			skill_status_change_start( bl,
				SkillStatusChangeTable[skillid], skilllv, 0 );
		}else{
			/* p[eBŜւ̏ */
			party_foreachsamemap(skill_area_sub,
				sd,1,
				src,skillid,skilllv,tick, flag|BCT_PARTY|1,
				skill_castend_nodamage_id);
		}
		break;

	/*itƉKvj */
	case BS_MAXIMIZE:		/* }LV}CYp[ */
	case NV_TRICKDEAD:		/* 񂾂ӂ */
	case TF_HIDING:			/* nCfBO */
	case AS_CLOAKING:		/* N[LO */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		{
			int sc=SkillStatusChangeTable[skillid];
			if( (battle_get_sc_data(bl))[sc].timer==-1 )
				/* t */
				skill_status_change_start(bl, sc, skilllv, 0);
			else
				/*  */
				skill_status_change_end(bl, sc, -1);

			if(skillid==AS_CLOAKING)
				skill_check_cloaking(bl);
		}
		break;

	/* ΒnXL */
	case BD_ETERNALCHAOS:		/* i̍ */
	case BD_DRUMBATTLEFIELD:	/* 푾ۂ̋ */
	case BD_RINGNIBELUNGEN:		/* j[xO̎w */
	case BD_SIEGFRIED:			/* sg̃W[Nt[h */
	case BA_WHISTLE:			/* J */
	case BA_ASSASSINCROSS:		/* [z̃ATVNX */
	case BA_APPLEIDUN:			/* ChD̗ь */
	case DC_FORTUNEKISS:		/* K^̃LX */
	case DC_SERVICEFORYOU:		/* T[rXtH[[ */
#if 0
	case BD_LULLABY:			/* qS */
	case BD_RICHMANKIM:			/* jh̉ */
	case BD_ETERNALCHAOS:		/* i̍ */
	case BD_DRUMBATTLEFIELD:	/* 푾ۂ̋ */
	case BD_RINGNIBELUNGEN:		/* j[xO̎w */
	case BD_ROKISWEIL:			/* L̋ */
	case BD_INTOABYSS:			/* [̒ */
	case BD_SIEGFRIED:			/* sg̃W[Nt[h */
	case BA_DISSONANCE:			/* sa */
	case BA_WHISTLE:			/* J */
	case BA_ASSASSINCROSS:		/* [z̃ATVNX */
	case BA_POEMBRAGI:			/* uM̎ */
	case BA_APPLEIDUN:			/* ChD̗ь */
	case DC_UGLYDANCE:			/* ȃ_X */
	case DC_HUMMING:			/* n~O */
	case DC_DONTFORGETME:		/* YȂŁc */
	case DC_FORTUNEKISS:		/* K^̃LX */
	case DC_SERVICEFORYOU:		/* T[rXtH[[ */
#endif
		skill_unitsetting(src,skillid,skilllv,src->x,src->y,0);
		break;

	case TF_STEAL:			// XeB[
		if(pc_steal_item(sd,bl)) {
			clif_skill_nodamage(src,bl,skillid,skilllv,1);
			mob_target((struct mob_data *)bl,src,skill_get_range(skillid));
		}
		else
			clif_skill_nodamage(src,bl,skillid,skilllv,0);
		break;

	case RG_STEALCOIN:		// XeB[RC
		if(pc_steal_coin(sd,bl)) {
			clif_skill_nodamage(src,bl,skillid,skilllv,1);
			mob_target((struct mob_data *)bl,src,skill_get_range(skillid));
		}
		else
			clif_skill_nodamage(src,bl,skillid,skilllv,0);
		break;

	case MG_STONECURSE:			/* Xg[J[X */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		if( rand()%100 < skilllv*4+20 )
			skill_status_change_start(bl,SC_STONE,skilllv,0);
		break;

	case NV_FIRSTAID:			/* }蓖 */
		clif_skill_nodamage(src,bl,skillid,5,1);
		battle_heal(NULL,bl,5,0);
		break;

	case AL_CURE:				/* LA[ */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		skill_status_change_end(bl, SC_SILENCE	, -1 );
		skill_status_change_end(bl, SC_BLIND	, -1 );
		skill_status_change_end(bl, SC_CONFUSION, -1 );
		break;

	case TF_DETOXIFY:			/*  */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		skill_status_change_end(bl, SC_POISON	, -1 );
		break;

	case PR_STRECOVERY:			/* Jo[ */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		skill_status_change_end(bl, SC_FREEZE	, -1 );
		skill_status_change_end(bl, SC_STONE	, -1 );
		skill_status_change_end(bl, SC_SLEEP	, -1 );
		skill_status_change_end(bl, SC_STAN		, -1 );
		break;

	case WZ_ESTIMATION:			/* X^[ */
		if(src->type==BL_PC){
			clif_skill_nodamage(src,bl,skillid,skilllv,1);
			clif_skill_estimation((struct map_session_data *)src,bl);
		}
		break;

	case MC_IDENTIFY:			/* ACeӒ */
		if(sd!=NULL)
			clif_item_identify_list(sd);
		break;

	case MC_VENDING:			/* IXJ */
		if(sd!=NULL)
			clif_openvendingreq(sd,2+sd->skilllv);
		break;

	case AL_TELEPORT:			/* e|[g */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		if( sd ){
			if(map[sd->bl.m].flag.noteleport)	/* e|֎~ */
				break;
			if( sd->skilllv==1 )
				pc_randomwarp(sd,3);
			else{
				clif_skill_warppoint(sd,sd->skillid,"Random",
					sd->status.save_point.map,"","");
			}
		}else if( bl->type==BL_MOB )
			mob_warp((struct mob_data *)bl,-1,-1,3);
		break;

	case AL_HOLYWATER:			/* ANAxlfBN^ */
	{
		int eflag;
		struct item item_tmp;
		memset(&item_tmp,0,sizeof(item_tmp));
		item_tmp.nameid=523;	// 
		item_tmp.identify=1;
		eflag = pc_additem(sd,&item_tmp,1);
		if(eflag)
			clif_additem(sd,0,0,eflag);
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		break;
	}

	case WZ_FROSTNOVA:			/* tXgm@ */
		skill_area_temp[1]=bl->id;
		skill_area_temp[2]=bl->x;
		skill_area_temp[3]=bl->y;
		/* ܂^[QbgɃGtFNgo */
/*		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		clif_skill_damage(src,bl,tick,battle_get_amotion(src),0,-1,1,skillid,skilllv,6);
		skill_attack(BF_MAGIC,src,src,bl,skillid,skilllv,tick, ); */
		/* ̌^[QbgȊO͈͓̔̓GŜɏs */
		map_foreachinarea(skill_area_sub,
			bl->m,bl->x-1,bl->y-1,bl->x+1,bl->y+1,0,
			src,skillid,skilllv,tick, flag|BCT_ENEMY|1,
			skill_castend_damage_id);
		break;

	case RG_STRIPWEAPON:		/* XgbvEF| */
		/*{
		int i,a=0,b=0;
		if(skilllv==1){a=1100 > 2000;}
        else if(skilllv==2){a=1100 > 2000;}
        else if(skilllv==3){a=1100 > 2000;}
        else if(skilllv==4){a=1100 > 2000;}
        else if(skilllv==5){a=1100 > 2000;}
		if(a>0){
           for(i=0;i<MAX_INVENTORY;i++){
          if(sd->status.inventory[i].nameid==a){
                 pc_unequipitem(sd,i);
                 b=1;
                 if(skilllv==1){a=rand()%7;}
                 else if(skilllv==2){a=rand()%9;}
                 else if(skilllv==3){a=rand()%11;}
                 else if(skilllv==4){a=rand()%13;}
                 else if(skilllv==5){a=rand()%15;}
		}
       if(b==0){clif_displaymessage(sd->fd,"Nothing Equiped.");}*/
		break;

	case RG_STRIPSHIELD:		/* XgbvV[h */
		/*{
		int i,a=0,b=0;
		if(skilllv==1){a=2100 > 2200;}
        else if(skilllv==2){a=2100 > 2200;}
        else if(skilllv==3){a=2100 > 2200;}
        else if(skilllv==4){a=2100 > 2200;}
        else if(skilllv==5){a=2100 > 2200;}
		if(a>0){
           for(i=0;i<MAX_INVENTORY;i++){
          if(sd->status.inventory[i].nameid==a){
                 pc_unequipitem(sd,i);
                 b=1;
                 if(skilllv==1){a=rand()%7;}
                 else if(skilllv==2){a=rand()%9;}
                 else if(skilllv==3){a=rand()%11;}
                 else if(skilllv==4){a=rand()%13;}
                 else if(skilllv==5){a=rand()%15;}
		}
       if(b==0){clif_displaymessage(sd->fd,"Nothing Equiped.");}*/
		break;
	case RG_STRIPARMOR:			/* XgbvA[}[ */
		/*{
		int i,a=0,b=0;
		if(skilllv==1){a=2300 > 2400;}
        else if(skilllv==2){a=2300 > 2400;}
        else if(skilllv==3){a=2300 > 2400;}
        else if(skilllv==4){a=2300 > 2400;}
        else if(skilllv==5){a=2300 > 2400;}
		if(a>0){
           for(i=0;i<MAX_INVENTORY;i++){
          if(sd->status.inventory[i].nameid==a){
                 pc_unequipitem(sd,i);
                 b=1;
                 if(skilllv==1){a=rand()%7;}
                 else if(skilllv==2){a=rand()%9;}
                 else if(skilllv==3){a=rand()%11;}
                 else if(skilllv==4){a=rand()%13;}
                 else if(skilllv==5){a=rand()%15;}
		}
       if(b==0){clif_displaymessage(sd->fd,"Nothing Equiped.");}*/
		break;
	case RG_STRIPHELM:			/* Xgbvw */
		/*{
		int i,a=0,b=0;
		if(skilllv==1){a=2200 > 2300;}
        else if(skilllv==2){a=2200 > 2300;}
        else if(skilllv==3){a=2200 > 2300;}
        else if(skilllv==4){a=2200 > 2300;}
        else if(skilllv==5){a=2200 > 2300;}
		if(a>0){
           for(i=0;i<MAX_INVENTORY;i++){
          if(sd->status.inventory[i].nameid==a){
                 pc_unequipitem(sd,i);
                 b=1;
                 if(skilllv==1){a=rand()%7;}
                 else if(skilllv==2){a=rand()%9;}
                 else if(skilllv==3){a=rand()%11;}
                 else if(skilllv==4){a=rand()%13;}
                 else if(skilllv==5){a=rand()%15;}
		}
       if(b==0){clif_displaymessage(sd->fd,"Nothing Equiped.");}*/
		break;
	case RG_INTIMIDATE:			/* CeB~fCg */
		if( sd ){
			if(map[sd->bl.m].flag.noteleport)	/* e|֎~ */
				break;
			if( sd->skilllv==1 )
				pc_randomwarp(sd,3);
			else{
				clif_skill_warppoint(sd,sd->skillid,"Random",
					sd->status.save_point.map,"","");
			}
		}else if( bl->type==BL_MOB )
			mob_warp((struct mob_data *)bl,-1,-1,3);
		break;
	/* PotionPitcher added by Tato [17/08/03] */
	case AM_POTIONPITCHER:		/* |[Vsb`[ */
		{
        int a=0,i,bonus,c=0;
        bonus=100+(skilllv*10);
        if(skilllv==1){a=501;}
        else if(skilllv==2){a=500 > 503;}
        else if(skilllv==3){a=500 > 504;}
        else if(skilllv==4){a=500 > 506;}
        else if(skilllv==5){a=500 > 507;}
        if(a>0){
           for(i=0;i<MAX_INVENTORY;i++){
          if(sd->status.inventory[i].nameid==a){
                 pc_delitem(sd,i,1,0);
                 c=1;
                 if(a==501){a=rand()%15+30;}
                 else if(a==502){a=rand()%20+70;}
                 else if(a==503){a=rand()%60+175;}
                 else if(a==504){a=rand()%80+350;}
                 else if(a==506){a=1;}
                 if(a>1){
                    clif_skill_nodamage(src,bl,skillid,(bonus*a)/100,1);
                    battle_heal(NULL,bl,(bonus*a)/100,0);
                 }else{
                    skill_status_change_end(bl, SC_POISON , -1 );
                    skill_status_change_end(bl, SC_SILENCE , -1 );
                    skill_status_change_end(bl, SC_BLIND , -1 );
                    skill_status_change_end(bl, SC_CONFUSION , -1 );
                 }
          }
       }
       if(c==0){clif_displaymessage(sd->fd,"Not enough Potions.");}
        }
	}
		break;
	case AM_CP_WEAPON:
		break;
	case AM_CP_SHIELD:
		break;
	case AM_CP_ARMOR:
		break;
	case AM_CP_HELM:
		break;
	case SA_DISPELL:			/* fBXy */
		clif_skill_nodamage(src,bl,skillid,skilllv,1);
		skill_status_change_end(bl, SC_SILENCE	, -1 );
		skill_status_change_end(bl, SC_BLIND	, -1 );
		skill_status_change_end(bl, SC_CONFUSION, -1 );
		skill_status_change_end(bl, SC_FREEZE	, -1 );
		skill_status_change_end(bl, SC_STONE	, -1 );
		skill_status_change_end(bl, SC_SLEEP	, -1 );
		skill_status_change_end(bl, SC_STAN		, -1 );
		skill_status_change_end(bl, SC_POISON	, -1 );
		break;

	case TF_BACKSLIDING:		/* obNXebv */
		battle_stopwalking(src,1);
		skill_blown(src,bl,5|0x10000);
		clif_fixpos(src);
		skill_addtimerskill(src,tick + 200,src->id,0,0,skillid,skilllv,0,flag);
		break;

	/* _ωAωAnA΁A */
	case NPC_ATTRICHANGE:
	case NPC_CHANGEWATER:
	case NPC_CHANGEGROUND:
	case NPC_CHANGEFIRE:
	case NPC_CHANGEWIND:
	/* ŁAAOA */
	case NPC_CHANGEPOISON:
	case NPC_CHANGEHOLY:
	case NPC_CHANGEDARKNESS:
	case NPC_CHANGETELEKINESIS:
		if(md){
			clif_skill_nodamage(src,bl,skillid,skilllv,1);
			md->def_ele=skill_get_pl(skillid);
			if(md->def_ele==0)			/* _ωAA*/
				md->def_ele=rand()%9;	/* s͏ */
			md->def_ele+=(1+rand()%4)*20;	/* x̓_ */
		}
		break;

	case NPC_SUICIDE:			/*  */
		if(md){
			clif_skill_nodamage(src,bl,skillid,skilllv,1);
			mob_damage(NULL,md,md->hp);
		}
		break;

	case NPC_SUMMONSLAVE:		/* 艺 */
	case NPC_SUMMONMONSTER:		/* MOB */
		if(md)
			mob_summonslave(md,mob_db[md->class].skill[md->skillidx].val1,
				skilllv,(skillid==NPC_SUMMONSLAVE)?1:0);
		break;

	case NPC_EMOTION:			/* G[V */
		clif_emotion(&md->bl,mob_db[md->class].skill[md->skillidx].val1);
		break;
	}
	return 0;
}


/*==========================================
 * XLgpirAIDwj
 *------------------------------------------
 */
int skill_castend_id( int tid, unsigned int tick, int id,int data )
{
	struct map_session_data* sd=NULL/*,*target_sd=NULL*/;
	struct block_list *bl;
	
	if( (sd=map_id2sd(id))==NULL || sd->bl.prev == NULL)
		return 0;
	
	if( sd->skilltimer != tid )	/* ^C}ID̊mF */
		return 0;
	sd->skilltimer=-1;
	
	bl=map_id2bl(sd->skilltarget);
	if(bl==NULL || bl->prev==NULL)
		return 0;
	if(sd->bl.m != bl->m || pc_isdead(sd))
		return 0;

	if(!skill_check_condition( sd ))		/* gp`FbN */
		return 0;
		
	printf("PC %d skill castend skill=%d\n",sd->bl.id,sd->skillid);

	if( (skill_get_inf(sd->skillid)&1) &&	// މGΊ֌W`FbN
		battle_check_target(&sd->bl,bl, BCT_ENEMY)<=0 )
		return 0;

	switch( skill_get_nk(sd->skillid) )
	{
	/* Un/΂n */
	case 0:	case 2:
		skill_castend_damage_id(&sd->bl,bl,sd->skillid,sd->skilllv,tick,0);
		break;
	case 1:/* xn */
		if( (sd->skillid==AL_HEAL || sd->skillid==ALL_RESURRECTION)&& battle_get_elem_type(bl)==9 )
			skill_castend_damage_id(&sd->bl,bl,sd->skillid,sd->skilllv,tick,0);
		else
			skill_castend_nodamage_id(&sd->bl,bl,sd->skillid,sd->skilllv,tick,0);
		break;
	}
	

	return 0;
}

/*==========================================
 * XLgpirAꏊw̎ۂ̏j
 *------------------------------------------
 */
int skill_castend_pos2( struct block_list *src, int x,int y,int skillid,int skilllv,unsigned int tick,int flag)
{
	struct map_session_data *sd=NULL;
	int i,tmpx = 0,tmpy = 0, x1 = 0, y1 = 0;

	if(src->type==BL_PC)
		sd=(struct map_session_data *)src;
	if(skillid != WZ_METEOR)
		clif_skill_poseffect(src,skillid,skilllv,x,y,tick);

	switch(skillid)
	{
	case MG_THUNDERSTORM:		/* T_[Xg[ */
	case WZ_HEAVENDRIVE:		/* wYhCu */
		skill_area_temp[1]=src->id;
		skill_area_temp[2]=x;
		skill_area_temp[3]=y;
		map_foreachinarea(skill_area_sub,
			src->m,x-2,y-2,x+2,y+2,0,
			src,skillid,skilllv,tick, flag|BCT_ENEMY|2,
			skill_castend_damage_id);
		break;

	case PR_BENEDICTIO:			/* ̍~ */
		skill_area_temp[1]=src->id;
		map_foreachinarea(skill_area_sub,
			src->m,x-1,y-1,x+1,y+1,0,
			src,skillid,skilllv,tick, flag|BCT_NOENEMY|1,
			skill_castend_nodamage_id);
		map_foreachinarea(skill_area_sub,
			src->m,x-1,y-1,x+1,y+1,0,
			src,skillid,skilllv,tick, flag|BCT_ENEMY|1,
			skill_castend_damage_id);
		break;

	case BS_HAMMERFALL:			/* n}[tH[ */
		skill_area_temp[1]=src->id;
		skill_area_temp[2]=x;
		skill_area_temp[3]=y;
		map_foreachinarea(skill_area_sub,
			src->m,x-2,y-2,x+2,y+2,0,
			src,skillid,skilllv,tick, flag|BCT_ENEMY|2,
			skill_castend_nodamage_id);
		break;

	case MG_SAFETYWALL:			/* ZCteBEH[ */
	case MG_FIREWALL:			/* t@C[EH[ */
	case AL_PNEUMA:				/* j[} */
	case WZ_ICEWALL:			/* ACXEH[ */
	case WZ_FIREPILLAR:			/* t@CAs[ */
	case WZ_QUAGMIRE:			/* N@O}CA */
	case WZ_VERMILION:			/* [hIu@[~I */
	case WZ_STORMGUST:			/* Xg[KXg */
	case PR_SANCTUARY:			/* TN`A */
	case PR_MAGNUS:				/* }OkXGN\VY */
	case HT_SKIDTRAP:			/* XLbhgbv */
	case HT_LANDMINE:			/* h}C */
	case HT_ANKLESNARE:			/* ANXlA */
	case HT_SHOCKWAVE:			/* VbNEF[ugbv */
	case HT_SANDMAN:			/* Th} */
	case HT_FLASHER:			/* tbV[ */
	case HT_FREEZINGTRAP:		/* t[WOgbv */
	case HT_BLASTMINE:			/* uXg}C */
	case HT_CLAYMORETRAP:		/* NCA[gbv */
	case AS_VENOMDUST:			/* xm_Xg */
		skill_unitsetting(src,skillid,skilllv,x,y,0);
		break;

	case WZ_METEOR:				//eIXg[
		for(i=0;i<2+(skilllv>>1);i++) {
			int j = 0, c;
			do {
				tmpx = x + (rand()%7 - 3);
				tmpy = y + (rand()%7 - 3);
				if(tmpx < 0)
					tmpx = 0;
				else if(tmpx >= map[src->m].xs)
					tmpx = map[src->m].xs - 1;
				if(tmpy < 0)
					tmpy = 0;
				else if(tmpy >= map[src->m].ys)
					tmpy = map[src->m].ys - 1;
				j++;
			} while(((c=map_getcell(src->m,x,y))==1 || c==5) && j<100);
			if(j >= 100)
				continue;

			if(i==0)
				clif_skill_poseffect(src,skillid,skilllv,tmpx,tmpy,tick);
			if(i > 0)
				skill_addtimerskill(src,tick+i*1000,0,tmpx,tmpy,skillid,skilllv,(x1<<16)|y1,flag);

			x1 = tmpx;
			y1 = tmpy;
		}
		skill_addtimerskill(src,tick+i*1000,0,tmpx,tmpy,skillid,skilllv,-1,flag);
		break;

	case AL_WARP:				/* [v|[^ */
		if(map[sd->bl.m].flag.noteleport)	/* e|֎~ */
			break;
		clif_skill_warppoint(sd,sd->skillid,sd->status.save_point.map,
			(sd->skilllv>1)?sd->status.memo_point[0].map:"",
			(sd->skilllv>2)?sd->status.memo_point[1].map:"",
			(sd->skilllv>3)?sd->status.memo_point[2].map:"");
		break;
	case MO_BODYRELOCATION:
		if(sd)
			pc_movepos(sd,x,y);
		break;
	}

	return 0;
}

/*==========================================
 * XLgpirAmapwj
 *------------------------------------------
 */
int skill_castend_map( struct map_session_data *sd,int skill_num, const char *map)
{
	int x=0,y=0;
	
	if( sd==NULL || sd->bl.prev == NULL || pc_isdead(sd))
		return 0;

	if( sd->opt1>0 || sd->status.option&6 || sd->sc_data[SC_DIVINA].timer!=-1 )
		return 0;	/* ُⒾقȂ */
	
	if( skill_num != sd->skillid)	/* spPbg炵 */
		return 0;

	pc_stopattack(sd);

	printf("PC %d skill castend skill =%d map=%s\n",sd->bl.id,skill_num,map);

	if(strcmp(map,"cancel")==0)
		return 0;

	switch(skill_num){
	case AL_TELEPORT:		/* e|[g */
		if(strcmp(map,"Random")==0)
			pc_randomwarp(sd,3);
		else
			pc_setpos(sd,sd->status.save_point.map,
				sd->status.save_point.x,sd->status.save_point.y,3);
		break;

	case AL_WARP:			/* [v|[^ */
		{
			const struct point *p[]={
				&sd->status.save_point,&sd->status.memo_point[0],
				&sd->status.memo_point[1],&sd->status.memo_point[2],
			};
			struct skill_unit_group *group;
			int i;
			for(i=0;i<sd->skilllv;i++){
				if(strcmp(map,p[i]->map)==0){
					x=p[i]->x;
					y=p[i]->y;
					break;
				}
			}
			if(x==0 || y==0)	/* spPbgH */
				return 0;

			group=skill_unitsetting(&sd->bl,sd->skillid,sd->skilllv,sd->skillx,sd->skilly,0);
			group->valstr=malloc(16);
			if(group->valstr==NULL){
				printf("skill_castend_map: out of memory !\n");
				exit(0);
			}
			memcpy(group->valstr,map,16);
			group->val2=(x<<16)|y;
		}
		break;

	case RG_INTIMIDATE:			/* CeB~fCg */
		if(strcmp(map,"Random")==0)
			pc_randomwarp(sd,3);
		else
			pc_setpos(sd,sd->status.save_point.map,
				sd->status.save_point.x,sd->status.save_point.y,3);
		break;
	}

	return 0;
}

/*==========================================
 * XLjbgݒ菈
 *------------------------------------------
 */
struct skill_unit_group *skill_unitsetting( struct block_list *src, int skillid,int skilllv,int x,int y,int flag)
{
	struct skill_unit_group *group;
	int i,count=1,limit=10000,val1=skilllv,val2=0;
	int target=BCT_ENEMY,interval=1000,range=0;
	int dir=0;

	switch(skillid){	/* ݒ */

	case MG_SAFETYWALL:			/* ZCteBEH[ */
		limit=5000*skilllv;
		val2=skilllv+1;
		target=(battle_config.defnotenemy)?BCT_NOENEMY:BCT_ALL;
		break;

	case MG_FIREWALL:			/* t@C[EH[ */
		dir=map_calc_dir(src,x,y);
		if(dir&1) count=5;
		else count=3;
		limit=1000*(val2=(4+skilllv));
		interval=250;
		break;

	case AL_PNEUMA:				/* j[} */
		target=(battle_config.defnotenemy)?BCT_NOENEMY:BCT_ALL;
		range=1;
		break;

	case AL_WARP:				/* [v|[^ */
		target=BCT_ALL;
		val1=skillid+6;
		if(flag==0)
			limit=2000;
		else
			limit=5000*(1+skilllv);
		break;

	case PR_SANCTUARY:			/* TN`A */
		count=21;
		limit=1000*(3*skilllv+1);
		val1=skilllv+3;
		val2=(skilllv>6)?777:skilllv*100;
		target=BCT_ALL;
		range=1;
		break;

	case PR_MAGNUS:				/* }OkXGN\VY */
		count=33;
		limit=1000*(skilllv+4);
		interval=3000;
		break;

	case WZ_FIREPILLAR:			/* t@CA[s[ */
		if(flag==0)
			limit=30000;
		else
			limit=1000;
		interval=2000;
		val1=skilllv+2;
		range=1;
		break;
	case WZ_METEOR:				/* eIXg[ */
		limit=500;
		interval=500;
		range=2;
		break;

	case WZ_VERMILION:			/* [hIu@[~I */
		limit=3500;
		interval=1500;
		range=4;
		break;

	case WZ_ICEWALL:			/* ACXEH[ */
		limit=4000*(1+skilllv);
		count=5;
		break;

	case WZ_STORMGUST:			/* Xg[KXg */
		limit=2000+skilllv*300;
		interval=450;
		range=4;
		break;

	case WZ_QUAGMIRE:			/* N@O}CA */
		limit=5000*skilllv;
		interval=200;
		count=25;
		break;

	case HT_SKIDTRAP:			/* XLbhgbv */
		limit=60000*(6-skilllv);
		range=1;
		break;

	case HT_LANDMINE:			/* h}C */
		limit=40000*(6-skilllv);
		range=1;
		break;

	case HT_ANKLESNARE:			/* ANXlA */
		limit=50000*(6-skilllv);
		range=1;
		val1=skilllv*5000;
		interval=val1+5000;
		break;

	case HT_SHOCKWAVE:			/* VbNEF[ugbv */
		limit=40000*(6-skilllv);
		range=1;
		val1=skilllv*15+10;
		break;

	case HT_SANDMAN:			/* Th} */
		limit=30000*(6-skilllv);
		range=1;
		break;

	case HT_FLASHER:			/* tbV[ */
		limit=30000*(6-skilllv);
		range=1;
		break;

	case HT_FREEZINGTRAP:		/* t[WOgbv */
		limit=30000*(6-skilllv);
		range=1;
		break;

	case HT_BLASTMINE:			/* uXg}C */
		limit=5000*(6-skilllv);
		interval=3000;
		range=1;
		break;

	case HT_CLAYMORETRAP:		/* NCA[gbv */
		limit=20000*(skilllv);
		interval=3000;
		range=1;
		break;

	case AS_VENOMDUST:			/* xm_Xg */
		limit=5000*skilllv;
		interval=1000;
		count=5;
		break;

	case CR_GRANDCROSS:			/* OhNX */
		count=33;
		limit=1000*(skilllv+4);
		interval=3000;
		break;

	case SA_VOLCANO:			/* {P[m */
		range=skilllv+4;
		target=BCT_ALL;
		break;

	case SA_DELUGE:				/* f[W */
		range=skilllv+4;
		target=BCT_ALL;
		break;

	case BD_DRUMBATTLEFIELD:	/* 푾ۂ̋ */
		count=81;
		limit=40000*(6-skilllv);
		val1=skilllv*15+10;
		target=BCT_ALL;
		break;

	case BD_SIEGFRIED:			/* sg̃W[Nt[h */
		count=81;
		target=BCT_ALL;
		break;

	case BA_DISSONANCE:			/* sa */
		count=81;
		target=BCT_ENEMY;
		break;

	case BA_WHISTLE:			/* J */
		count=81;
		limit=40000*(6-skilllv);
		range=9;
		val1=skilllv*15+10;
		target=BCT_ALL;
		break;

	case BA_APPLEIDUN:			/* ChD̗ь */
		count=81;
		target=BCT_ALL;
		break;

	case DC_UGLYDANCE:			/* ȃ_X */
		count=81;
		limit=40000*(6-skilllv);
		range=5;
		val1=skilllv*15+10;
		target=BCT_ALL;
		break;

	case DC_FORTUNEKISS:		/* K^̃LX */
		count=81;
		limit=40000*(6-skilllv);
		val1=skilllv*15+10;
		target=BCT_ALL;
		break;

	case DC_SERVICEFORYOU:		/* T[rXtH[[ */
		count=81;
		limit=40000*(6-skilllv);
		val1=skilllv*15+10;
		target=BCT_ALL;
		break;
	};

	group=skill_initunitgroup(src,count,skillid,skilllv,
		skill_get_unit_id(skillid,flag&1));
	group->limit=limit;
	group->val1=val1;
	group->val2=val2;
	group->target_flag=target;
	group->interval=interval;
	group->range=range;

	for(i=0;i<count;i++){
		struct skill_unit *unit;
		int ux=x,uy=y,val1=skilllv,val2=0,limit=group->limit,alive=1;
		int range=0;
		switch(skillid){	/* ݒ */
		case MG_FIREWALL:		/* t@C[EH[ */
		{
				if(dir&1){	/* ΂ߔzu */
					static const int dx[][5]={
						{ 1,1,0,0,-1 }, { -1,-1,0,0,1 },
					},dy[][5]={
						{ 1,0,0,-1,-1 }, { 1,0,0,-1,-1 },
					};
					ux+=dx[(dir>>1)&1][i];
					uy+=dy[(dir>>1)&1][i];
				}else{	/* ㉺zu */
					if(dir%4==0)	/* ㉺ */
						ux+=i-1;
					else			/* E */
						uy+=i-1;
				}
				val2=group->val2;
			}
			break;

		case PR_SANCTUARY:		/* TN`A */
			{
				static const int dx[]={
					-1,0,1, -2,-1,0,1,2, -2,-1,0,1,2, -2,-1,0,1,2, -1,0,1 };
				static const int dy[]={
					-2,-2,-2, -1,-1,-1,-1,-1, 0,0,0,0,0, 1,1,1,1,1, 2,2,2, };
				ux+=dx[i];
				uy+=dy[i];
			}
			break;

		case PR_MAGNUS:			/* }OkXGN\VY */
			{
				static const int dx[]={ -1,0,1, -1,0,1, -3,-2,-1,0,1,2,3,
					-3,-2,-1,0,1,2,3, -3,-2,-1,0,1,2,3, -1,0,1, -1,0,1, };
				static const int dy[]={
					-3,-3,-3, -2,-2,-2, -1,-1,-1,-1,-1,-1,-1,
					0,0,0,0,0,0,0, 1,1,1,1,1,1,1, 2,2,2, 3,3,3 };
				ux+=dx[i];
				uy+=dy[i];
			}
			break;

		case WZ_ICEWALL:		/* ACXEH[ */
			{
				static const int dirx[8]={0,-1,-1,-1,0,1,1,1};
				static const int diry[8]={1,1,0,-1,-1,-1,0,1};
				dir=map_calc_dir(src,x,y);
				ux+=(2-i)*diry[dir];
				uy+=(i-2)*dirx[dir];
				val2=map_getcell(src->m,ux,uy);
				if(val2==5 || val2==1)
					alive=0;
				else {
					map_setcell(src->m,ux,uy,5);
					clif_changemapcell(src->m,ux,uy,5,0);
				}
			}
			break;

		case WZ_QUAGMIRE:		/* N@O}CA */
			ux+=(i%5-2);
			uy+=(i/5-2);
			break;

		case AS_VENOMDUST:		/* xm_Xg */
			{
				static const int dx[]={-1,0,0,0,1};
				static const int dy[]={0,-1,0,1,0};
				ux+=dx[i];
				uy+=dy[i];
			}
			break;

		/* _XȂ */
		case BD_LULLABY:		/* q */
		case BD_RICHMANKIM:		/* jh̉ */
		case BD_ETERNALCHAOS:	/* i̍ */
		case BD_DRUMBATTLEFIELD:/* 푾ۂ̋ */
		case BD_RINGNIBELUNGEN:	/* j[xO̎w */
		case BD_ROKISWEIL:		/* L̋ */
		case BD_INTOABYSS:		/* [̒ */
		case BD_SIEGFRIED:		/* sg̃W[Nt[h */
		case BA_DISSONANCE:		/* sa */
		case BA_WHISTLE:		/* J */
		case BA_ASSASSINCROSS:	/* [z̃ATVNX */
		case BA_POEMBRAGI:		/* uM̎ */
		case BA_APPLEIDUN:		/* ChD̗ь */
		case DC_UGLYDANCE:		/* ȃ_X */
		case DC_HUMMING:		/* n~O */
		case DC_DONTFORGETME:	/* YȂŁc */
		case DC_FORTUNEKISS:	/* K^̃LX */
		case DC_SERVICEFORYOU:	/* T[rXtH[[ */
			ux+=(i%9-4);
			uy+=(i/9-4);
			if(i==40)
				range=4;	/* S̏ꍇ͔͈͂4ɃI[o[Ch */
			else
				range=-1;	/* SȂꍇ͔͈͂-1ɃI[o[Ch */
			break;
		}
		if(alive){
			unit=skill_initunit(group,i,ux,uy);
			unit->val1=val1;
			unit->val2=val2;
			unit->limit=limit;
			unit->range=range;
		}
	}
	return group;
}



/*==========================================
 * XLjbg̔Cxg
 *------------------------------------------
 */
int skill_unit_onplace(struct skill_unit *src,struct block_list *bl,unsigned int tick)
{
	struct skill_unit_group *sg= src->group;
	struct block_list *ss=map_id2bl(sg->src_id);
	struct skill_unit_group_tickset *ts;
	int diff,goflag;
	
	
	if(bl == NULL ||  bl->prev==NULL || !src->alive)
		return 0;
	if( bl->type!=BL_PC && bl->type!=BL_MOB )
		return 0;

	if(ss==NULL)
		return 0;

	ts=skill_unitgrouptickset_search( bl, sg->group_id);
	diff=DIFF_TICK(tick,ts->tick);
	goflag=(diff>sg->interval || diff<0);
	if(!goflag)
		return 0;
	ts->tick=tick;
	ts->group_id=sg->group_id;

	switch(sg->unit_id){
	case 0x83:	/* TN`A */
		{
			int *list=sg->vallist;
			int i,ei=0,race=battle_get_race(bl);
			int element=battle_get_element(bl) % 10;

			if(!battle_config.sanctuary_type) {
				if( battle_get_hp(bl)>=battle_get_max_hp(bl) &&
					 race!=1 && race!=6  )
					break;

				for(i=0;i<16;i++)	/* ľvZ */
					if(list[i]==0)
						ei=i;
					else if(list[i]==bl->id)
						break;
				if(i==16){
					list[ei]=bl->id;
					if((sg->val1--)<=0){
						skill_delunitgroup(sg);
						return 0;
					}
				}
				if( race!=1 && race!=6 ){
					int heal=sg->val2;
					if( bl->type==BL_PC &&
						pc_check_equip_dcard((struct map_session_data *)bl,4128) )
						heal=0;	/* 峃J[hiq[ʂOj */
					clif_skill_nodamage(&src->bl,bl,/*sg->skill_id*/28,heal,1);
					battle_heal(NULL,bl,heal,0);
				}else
					skill_attack(BF_MAGIC,ss,&src->bl,bl,
						sg->skill_id,sg->skill_lv,tick,0);
			}
			else {
				if( battle_get_hp(bl)>=battle_get_max_hp(bl) &&
					 element!=9 && race!=6  )
					break;

				for(i=0;i<16;i++)	/* ľvZ */
					if(list[i]==0)
						ei=i;
					else if(list[i]==bl->id)
						break;
				if(i==16){
					list[ei]=bl->id;
					if((sg->val1--)<=0){
						skill_delunitgroup(sg);
						return 0;
					}
				}
				if( element!=9 && race!=6 ){
					int heal=sg->val2;
					if( bl->type==BL_PC &&
						pc_check_equip_dcard((struct map_session_data *)bl,4128) )
						heal=0;	/* 峃J[hiq[ʂOj */
					clif_skill_nodamage(&src->bl,bl,/*sg->skill_id*/28,heal,1);
					battle_heal(NULL,bl,heal,0);
				}else
					skill_attack(BF_MAGIC,ss,&src->bl,bl,
						sg->skill_id,sg->skill_lv,tick,0);
			}
		}
		break;

	case 0x84:	/* }OkXGN\VY */
		{
			int race=battle_get_race(bl);
			int element=battle_get_element(bl) % 10;
			if(!battle_config.sanctuary_type) {
				if( race!=1 && race!=6 )
					return 0;
			}
			else {
				if(element!=9 && race!=6  )
					return 0;
			}
			skill_attack(BF_MAGIC,ss,&src->bl,bl,
				sg->skill_id,sg->skill_lv,tick,0);
		}
		break;

	case 0x85:	/* j[} */
	case 0x7e:	/* ZCteBEH[ */
		{
			struct skill_unit *unit2;
			struct status_change *sc_data=battle_get_sc_data(bl);
			int type=(sg->unit_id==0x85)?SC_PNEUMA:SC_SAFETYWALL;
			if(sc_data[type].timer==-1)
				skill_status_change_start(bl,type,src->group->val1,(int)src);
			else if((unit2=(struct skill_unit *)sc_data[type].val2)!=src){
				if( sg->unit_id==0x85 && DIFF_TICK(sg->tick,unit2->group->tick)>0 )
					skill_status_change_start(bl,type,src->group->val1,(int)src);
				if( sg->unit_id==0x7e && sg->val1 < unit2->group->val1 )
					skill_status_change_start(bl,type,src->group->val1,(int)src);
				ts->tick-=sg->interval;
			}
		} break;

	case 0x86:	/* [hIu@[~I(Xg[KXg) */
		skill_attack(BF_MAGIC,ss,&src->bl,bl,
			sg->skill_id,sg->skill_lv,tick,0);
		break;

	case 0x7f:	/* t@C[EH[ */
		if( (src->val2--)>0)
			skill_attack(BF_MAGIC,ss,&src->bl,bl,
				sg->skill_id,sg->skill_lv,tick,0);
		if( src->val2<=0 )
			skill_delunit(src);
		break;

	case 0x87:	/* t@CA[s[(O) */
		skill_delunit(src);
		skill_unitsetting(ss,sg->skill_id,sg->skill_lv,src->bl.x,src->bl.y,1);
		break;

	case 0x88:	/* t@CA[s[() */
		skill_attack(BF_MAGIC,ss,&src->bl,bl,sg->skill_id,sg->skill_lv,tick,0);
		break;

	case 0x90:	/* XLbhgbv */
		if(sg->val2==0){
			int i;
			for(i=0;i<sg->skill_lv;i++)
				skill_blown(&src->bl,bl,1|0x30000);
			sg->limit=DIFF_TICK(tick,sg->tick)+3000;
			sg->val2=bl->id;
		}
		break;

	case 0x93:	/* h}C */
		skill_attack(BF_MISC,ss,&src->bl,bl,sg->skill_id,sg->skill_lv,tick,0);
		skill_delunit(src);
		break;

	case 0x8f:	/* uXg}C */
	case 0x97:	/* t[WOgbv */
	case 0x98:	/* NCA[gbv */
		skill_attack((sg->unit_id==0x97)?BF_WEAPON:BF_MISC,
			ss,&src->bl,bl,sg->skill_id,sg->skill_lv,tick,(sg->val2)?0x0500:0);
		if(sg->val2==0){
			sg->limit=DIFF_TICK(tick,sg->tick)+500;
			sg->val2=bl->id;
		}
		break;

	case 0x95:	/* Th} */
	case 0x96:	/* tbV[ */
	case 0x94:	/* VbNEF[ugbv */
	case 0x91:	/* ANXlA */
		skill_additional_effect(ss,bl,sg->skill_id,sg->skill_lv,tick);
		if(sg->val2==0){
			sg->limit=DIFF_TICK(tick,sg->tick)
				+((sg->unit_id==0x91)?sg->val1/((battle_get_mode(bl)&0x20)?5:1):500);
			sg->val2=bl->id;
		}
		break;

	case 0x80:	/* [v|[^() */
		if(bl->type==BL_PC){
			if((sg->val1--)>0){
				pc_setpos((struct map_session_data *)bl,
					sg->valstr,sg->val2>>16,sg->val2&0xffff,0);
			}else
				skill_delunitgroup(sg);
		}
		break;

	case 0x8e:	/* N@O}CA */
	case 0x92:	/* xm_Xg */
		{
			int type=SkillStatusChangeTable[sg->skill_id];
			if( battle_get_sc_data(bl)[type].timer==-1 )
				skill_status_change_start(bl,type,src->group->val1,(int)src);
		}
		break;

	case 0x9e:	/* qS */
	case 0x9f:	/* jh̉ */
	case 0xa0:	/* i̍ */
	case 0xa1:	/* 푾ۂ̋ */
	case 0xa2:	/* j[xO̎w */
	case 0xa3:	/* L̋ */
	case 0xa4:	/* [̒ */
	case 0xa5:	/* sg̃W[Nt[h */
	case 0xa6:	/* sa */
	case 0xa7:	/* J */
	case 0xa8:	/* [z̃ATVNX */
	case 0xa9:	/* uM̎ */
	case 0xaa:	/* ChD̗ь */
	case 0xab:	/* ȃ_X */
	case 0xac:	/* n~O */
	case 0xad:	/* YȂŁc */
	case 0xae:	/* K^̃LX */
	case 0xaf:	/* T[rXtH[[ */
		{
			struct skill_unit *unit2;
			struct status_change *sc_data=battle_get_sc_data(bl);
			int type=SkillStatusChangeTable[sg->skill_id];
			if(sc_data[type].timer==-1)
				skill_status_change_start(bl,type,src->group->val1,(int)src);
			else if((unit2=(struct skill_unit *)sc_data[type].val4)!=src){
				if( DIFF_TICK(sg->tick,unit2->group->tick)>0 )
					skill_status_change_start(bl,type,0,(int)src);
/*				if( sg->unit_id==0x7e && sg->val1 < unit2->group->val1 )
					skill_status_change_start(bl,type,0,(int)src);*/
				ts->tick-=sg->interval;
			}
		} break;

/*	default:
		printf("skill_unit_onplace: Unknown skill unit id=%d block=%d\n",sg->unit_id,bl->id);
		break;*/
	}
	return 0;
}
/*==========================================
 * XLjbg痣E(͂Ă)ꍇ
 *------------------------------------------
 */
int skill_unit_onout(struct skill_unit *src,struct block_list *bl,unsigned int tick)
{
	struct skill_unit_group *sg= src->group;

	if(bl == NULL || bl->prev==NULL || !src->alive)
		return 0;
	if( bl->type!=BL_PC && bl->type!=BL_MOB )
		return 0;

	switch(sg->unit_id){
	case 0x83:	/* TN`A */
		{
			int i,*list=sg->vallist;
			for(i=0;i<list[i];i++)
				if(list[i]==bl->id)
					list[i]=0;
		}
		break;

	case 0x7e:	/* ZCteBEH[ */
	case 0x85:	/* j[} */
	case 0x8e:	/* N@O}CA */
		{
			struct skill_unit *unit2;
			struct status_change *sc_data=battle_get_sc_data(bl);
			int type=
				(sg->unit_id==0x85)?SC_PNEUMA:
				((sg->unit_id==0x7e)?SC_SAFETYWALL:
				 SC_QUAGMIRE);
			if(sc_data[type].timer!=-1 && (unit2=(struct skill_unit *)sc_data[type].val2)==src){
				skill_status_change_end(bl,type,-1);
			}
		} break;

	case 0x91:	/* ANXlA */
		{
			struct block_list *target=map_id2bl(sg->val2);
			if( target==bl )
				skill_status_change_end(bl,SC_ANKLE,-1);
			sg->limit=DIFF_TICK(tick,sg->tick)+1000;
		}
		break;

	case 0x9e:	/* qS */
	case 0x9f:	/* jh̉ */
	case 0xa0:	/* i̍ */
#if 0
	case 0xa1:	/* 푾ۂ̋ */
#endif
	case 0xa2:	/* j[xO̎w */
	case 0xa3:	/* L̋ */
#if 0
	case 0xa4:	/* [̒ */
#endif
	case 0xa5:	/* sg̃W[Nt[h */
#if 0
	case 0xa6:	/* sa */
	case 0xa7:	/* J */
#endif
	case 0xa8:	/* [z̃ATVNX */
#if 0
	case 0xa9:	/* uM̎ */
#endif
	case 0xaa:	/* ChD̗ь */
#if 0
	case 0xab:	/* ȃ_X */
	case 0xac:	/* n~O */
#endif
	case 0xad:	/* YȂŁc */
	case 0xae:	/* K^̃LX */
#if 0
	case 0xaf:	/* T[rXtH[[ */
#endif
		{
			struct skill_unit *unit2;
			struct status_change *sc_data=battle_get_sc_data(bl);
			int type=SkillStatusChangeTable[sg->skill_id];
			if(sc_data[type].timer!=-1 && (unit2=(struct skill_unit *)sc_data[type].val4)==src){
				skill_status_change_end(bl,type,-1);
			}
		}
		break;

/*	default:
		printf("skill_unit_onout: Unknown skill unit id=%d block=%d\n",sg->unit_id,bl->id);
		break;*/
	}
	skill_unitgrouptickset_delete(bl,sg->group_id);
	return 0;
}
/*==========================================
 * XLjbg̍폜Cxg
 *------------------------------------------
 */
int skill_unit_ondelete(struct skill_unit *src,struct block_list *bl,unsigned int tick)
{
	struct skill_unit_group *sg= src->group;
	
	if(bl == NULL || bl->prev==NULL || !src->alive)
		return 0;
	if( bl->type!=BL_PC && bl->type!=BL_MOB )
		return 0;

	switch(sg->unit_id){
	case 0x85:	/* j[} */
	case 0x7e:	/* ZCteBEH[ */
	case 0x8e:	/* N@O}C */
	case 0x9e:	/* qS */
	case 0x9f:	/* jh̉ */
	case 0xa0:	/* i̍ */
	case 0xa1:	/* 푾ۂ̋ */
	case 0xa2:	/* j[xO̎w */
	case 0xa3:	/* L̋ */
	case 0xa4:	/* [̒ */
	case 0xa5:	/* sg̃W[Nt[h */
	case 0xa6:	/* sa */
	case 0xa7:	/* J */
	case 0xa8:	/* [z̃ATVNX */
	case 0xa9:	/* uM̎ */
	case 0xaa:	/* ChD̗ь */
	case 0xab:	/* ȃ_X */
	case 0xac:	/* n~O */
	case 0xad:	/* YȂŁc */
	case 0xae:	/* K^̃LX */
	case 0xaf:	/* T[rXtH[[ */
		return skill_unit_onout(src,bl,tick);

/*	default:
		printf("skill_unit_ondelete: Unknown skill unit id=%d block=%d\n",sg->unit_id,bl->id);
		break;*/
	}
	skill_unitgrouptickset_delete(bl,sg->group_id);
	return 0;
}
/*==========================================
 * XLjbǧECxg
 *------------------------------------------
 */
int skill_unit_onlimit(struct skill_unit *src,unsigned int tick)
{
	struct skill_unit_group *sg= src->group;
	

	switch(sg->unit_id){
	case 0x81:	/* [v|[^(O) */
		{
			struct skill_unit_group *group=
				skill_unitsetting(map_id2bl(sg->src_id),sg->skill_id,sg->skill_lv,
					src->bl.x,src->bl.y,1);
			group->valstr=malloc(16);
			if(group->valstr==NULL){
				printf("skill_unit_ondelete: out of memory !\n");
				exit(0);
			}
			memcpy(group->valstr,sg->valstr,16);
			group->val2=sg->val2;
		}
		break;

	case 0x8d:	/* ACXEH[ */
		map_setcell(src->bl.m,src->bl.x,src->bl.y,src->val2);
		clif_changemapcell(src->bl.m,src->bl.x,src->bl.y,src->val2,1);
		break;
			
	}
	return 0;
}
/*==========================================
 * XLjbg̃_[WCxg
 *------------------------------------------
 */
int skill_unit_ondamaged(struct skill_unit *src,struct block_list *bl,
	int damage,unsigned int tick)
{
	struct skill_unit_group *sg= src->group;
	
	switch(sg->unit_id){
	case 0x8d:	/* ACXEH[ */
		sg->limit-=damage;
		break;
	}
	return 0;
}


/*---------------------------------------------------------------------------- */



/*==========================================
 * XLgpirAꏊwj
 *------------------------------------------
 */
int skill_castend_pos( int tid, unsigned int tick, int id,int data )
{
	struct map_session_data* sd=NULL/*,*target_sd=NULL*/;
	
	if( (sd=map_id2sd(id))==NULL )
		return 0;
	
	if( sd->skilltimer != tid )	/* ^C}ID̊mF */
		return 0;
	sd->skilltimer=-1;

	if(pc_isdead(sd))
		return 0;
	
	if(!skill_check_condition( sd ))		/* gp`FbN */
		return 0;

	printf("PC %d skill castend skill=%d\n",sd->bl.id,sd->skillid);

	skill_castend_pos2(&sd->bl,sd->skillx,sd->skilly,sd->skillid,sd->skilllv,tick,0);

	return 0;
}

/*==========================================
 * XLgpiUŎgpsj
 *------------------------------------------
 */
int skill_check_condition( struct map_session_data *sd )
{
	int j=0,sp=0,zeny=0,spiritball=0,tick;
	int	i[3]={0,0,0},
		item_id[3]={0,0,0},
		item_amount[3]={0,0,0};

	if( sd->opt1>0) {
		clif_skill_fail(sd,sd->skillid,0,0);
		return 0;
	}

	if(sd->skillitem==sd->skillid) {	/* ACȅꍇ */
		sd->skillitem = sd->skillitemlv = -1;
	}else{
		if(sd->sc_data[SC_DIVINA].timer!=-1 || sd->sc_data[SC_STEELBODY].timer!=-1) {
			clif_skill_fail(sd,sd->skillid,0,0);
			return 0;
		}

		sp=skill_get_sp(sd->skillid, sd->skilllv);	/* SP */
		if(sd->dsprate!=100)
			sp=sp*sd->dsprate/100;	/* SPC */
		
		/* XLƂ̎gp */
		switch(sd->skillid)
		{
		case SA_ABRACADABRA:
			item_amount[0]+=1;
			break;
		case SA_VOLCANO:
		case SA_DELUGE:
		case SA_VIOLENTGALE:
			item_id[0]=715;		//	yellow_gem = 715;
			item_amount[0]+=1;
			break;

		case SA_DISPELL:
			item_id[1]=715;		//	yellow_gem = 715;
			item_amount[1]+=1;
			break;
		case MG_STONECURSE:		// Xg[J[X
		case AS_VENOMDUST:		// xi_Xg
			item_id[0]=716;		//	red_gem = 716;
			item_amount[0]+=1;
			break;

		case SA_LANDPROTECTOR:
			item_id[1]=715;		//	yellow_gem = 715;
			item_amount[1]+=1;
			break;
		case MG_SAFETYWALL:		// ZCteBEH[
		case AL_WARP:			// [v|[^
		case ALL_RESURRECTION:	// UNV
		case PR_SANCTUARY:		// TN`A
		case PR_MAGNUS:			// }OkXGN\VY
		case WZ_FIREPILLAR:		// t@CA[s[
			item_id[0]=717;		//	blue_gem = 717;
			item_amount[0]+=1;
			break;

		case SA_FLAMELAUNCHER:
			item_id[0]=990;		// Ό
			item_amount[0]+=1;
			break;

		case SA_FROSTWEAPON:
			item_id[0]=991;		// 
			item_amount[0]+=1;
			break;

		case SA_LIGHTNINGLOADER:
			item_id[0]=992;		// 
			item_amount[0]+=1;
			break;

		case SA_SEISMICWEAPON:
			item_id[0]=993;		// n
			item_amount[0]+=1;
			break;

		case HT_TALKIEBOX:	/* g[L[{bNX */
		case HT_BLASTMINE:	/* uXg}C */
		case HT_SKIDTRAP:	/* XLbhgbv */
		case HT_ANKLESNARE:	/* ANXlA */
		case HT_LANDMINE:	/* h}C */
		case HT_SHOCKWAVE:	/* VbNEF[ugbv */
		case HT_SANDMAN:	/* Th} */
		case HT_FLASHER:	/* tbV[ */
		case HT_FREEZINGTRAP:	/* t[WOgbv */
		case HT_CLAYMORETRAP:	/* NCA[gbv */
			item_id[0]=1065;		//	ݒupgbv;
			item_amount[0]+=1;
			break;

		case AL_HOLYWATER:	/* ANAxlfBN^ */
			if(map[sd->bl.m].flag.water_flag != 2) {
				if(!map[sd->bl.m].flag.water_flag || map_getcell(sd->bl.m,sd->bl.x,sd->bl.y)!=3){	//ꔻ
					clif_skill_fail(sd,sd->skillid,0,0);
					return 0;
				}
			}
			item_id[0]=713;			//	󂫃r;
			item_amount[0]+=1;
			break;

		case PR_ASPERSIO:	/* AXyVI */
			item_id[0]=523;			//	;
			item_amount[0]+=1;
			break;

		case WZ_WATERBALL:	/* EH[^[{[ */
			if(map[sd->bl.m].flag.water_flag != 2) {
				if(!map[sd->bl.m].flag.water_flag || map_getcell(sd->bl.m,sd->bl.x,sd->bl.y)!=3){	//ꔻ
					clif_skill_fail(sd,sd->skillid,0,0);
					return 0;
				}
			}
			break;

		case MC_MAMMONITE:		/* }[iCg */
			zeny = sd->skilllv*100;
			if( sd->status.zeny<zeny ) {
				clif_skill_fail(sd,sd->skillid,5,0);	/* ZenysFsʒm */
				return 0;
			}
			break;

		case MC_VENDING:		// IXJ	
			if(!pc_iscarton(sd)) {
				clif_skill_fail(sd,sd->skillid,0,0);
				return 0;
			}
			break;

		case AC_DOUBLE:		// _uXgCtBO
		case AC_SHOWER:		// A[V[
		case AC_CHARGEARROW:		// `[WA[
			if( sd->status.weapon != 11) {
				clif_skill_fail(sd,sd->skillid,6,0);	// |
		     	return 0; 
			}
			break;

		case KN_BRANDISHSPEAR:	// ufBbVXsA
			if(!pc_isriding(sd)) {
				clif_skill_fail(sd,sd->skillid,0,0);
				return 0;		// ,yRyR
			}
			break;

		case KN_PIERCE:			// sA[X
		case KN_SPEARSTAB:		// XsAX^u
		case KN_SPEARBOOMERANG:	// XsAu[
			if(sd->status.weapon != 4 && sd->status.weapon != 5) {
				clif_skill_fail(sd,sd->skillid,6,0);	// 
				return 0; 
			}
			break;

		case KN_TWOHANDQUICKEN:	// c[nhNCbP
			if( sd->status.weapon != 3) {
				clif_skill_fail(sd,sd->skillid,6,0);	// 茕
				return 0;
			}
			break;
			
		case BS_ADRENALINE:		// AhibV
		case BS_HAMMERFALL:		// n}[tH[
			if( sd->status.weapon != 6 && sd->status.weapon != 7 && sd->status.weapon != 8) {
				clif_skill_fail(sd,sd->skillid,6,0);	// EŃCX
				return 0;
			}
			break;

		case BS_MAXIMIZE:		/* }LV}CYp[ */
		case NV_TRICKDEAD:		/* 񂾂ӂ */
		case TF_HIDING:			/* nCfBO */
		case AS_CLOAKING:		/* N[LO */
			if(sd->sc_data[SkillStatusChangeTable[sd->skillid]].timer!=-1)
				sp=0;			/* ꍇSPȂ */
			break;

		case HT_BLITZBEAT:		/* ubcr[g */
			if(!pc_isfalcon(sd)) {		/* 邪Ȃ */
				clif_skill_fail(sd,sd->skillid,0,0);
				return 0;
			}
			break;

		case AS_GRIMTOOTH:	/* OgD[X */
			if(!pc_ishiding(sd)) {		// nCfBO
				clif_skill_fail(sd,sd->skillid,0,0);
				return 0;
			}
			if( sd->status.weapon != 16)  {
				clif_skill_fail(sd,sd->skillid,6,0);    	// J^[
				return 0; 
			}
			break;

		case CR_SPEARQUICKEN:	// XsANCbP
			if( sd->status.weapon != 5) {
				clif_skill_fail(sd,sd->skillid,6,0);	// 葄
				return 0;
			}
			break;

		case MO_CALLSPIRITS:
			if(sd->spiritball >= ((sd->skilllv > 10)? 10:sd->skilllv)) {
				clif_skill_fail(sd,sd->skillid,0,0);
				return 0;
			}
			break;

		case MO_EXTREMITYFIST:					// CeP
			tick = gettick();
			if( sd->sc_data[SC_EXPLOSIONSPIRITS].timer == -1) {
				clif_skill_fail(sd,sd->skillid,0,0);
				return 0;
			}
			else {
				if(sd->combo_delay3 <= tick && tick <= sd->combo_delay3 + battle_config.asuradelay) 
					spiritball = 4;				// 
				else spiritball = 5;			// 
			}
			sd->skill_old = 0;
			break;

		case MO_FINGEROFFENSIVE:				//we
			spiritball = sd->skilllv;			// 
			if (sd->spiritball > 0 && sd->spiritball < spiritball) {
				spiritball = sd->spiritball;
				sd->spiritball_old = sd->spiritball;	
			}
			else sd->spiritball_old = sd->skilllv;	
			break;

		case MO_INVESTIGATE:					//
			spiritball = 1;						// 
			break;

		case MO_BODYRELOCATION:
			if(!pc_can_reach(sd,sd->skillx,sd->skilly)) {
				clif_skill_fail(sd,sd->skillid,0,0);
				return 0;
			} else
				spiritball = 1;					// 
			break;
		
		case MO_STEELBODY:						// 
		case MO_EXPLOSIONSPIRITS:				// g
				spiritball = 5;					// 
			break;

		case MO_CHAINCOMBO:						//Aŏ
			tick = gettick();
			if(sd->combo_delay1 <= tick && tick <= sd->combo_delay1 + 300) {
				if(sd->skill_old == sd->skillid)
					return 0;
				sd->skill_old = sd->skillid;
				break;
			}
			else {
				sd->skill_old = 0;
				return 0;
			}
			break;

		case MO_COMBOFINISH:					//җ
			tick = gettick();
			spiritball = 1;
			if(sd->combo_delay2 <= tick && tick <= sd->combo_delay2 + 300) {
				if(sd->skill_old == sd->skillid)
					return 0;
				sd->skill_old = sd->skillid;
				break;
			}
			else {
				sd->skill_old = 0;
				return 0;
			}
			break;

//		case RG_BACKSTAP:	// obNX^u
		case RG_RAID:		// TvCYA^bN
			if(!pc_ishiding(sd)) {		// nCfBO
				clif_skill_fail(sd,sd->skillid,0,0);
				return 0;
			}
			break;

	}

		if( sp>0 && sd->status.sp < sp) {				/* SP`FbN */
			clif_skill_fail(sd,sd->skillid,1,0);		/* SPsFsʒm */
			return 0;
		}
		
		if( spiritball > 0 && sd->spiritball < spiritball) {
			clif_skill_fail(sd,sd->skillid,0,0);		// s
			return 0;
		}

		if	(item_id[0] || item_id[1] || item_id[2]) {
			for(j=0;j<3;j++) {
				if(!item_id[j] ||
						 ((item_id[j] == 715 || item_id[j] == 716 || item_id[j] == 717) &&  pc_check_equip_dcard(sd,4132)))
					continue;	// ACeARWF~XgXJ[hA͖
				if((i[j]=pc_search_inventory(sd,item_id[j])) == -1 ||
						sd->status.inventory[i[j]].amount < item_amount[j]) {	// ACeȂ
					if(item_id[j] == 716 || item_id[j] == 717)		// ԁWF̏ꍇ̂
						clif_skill_fail(sd,sd->skillid,(6+(item_id[j]-715)),0);
					else
						clif_skill_fail(sd,sd->skillid,0,0);
					return 0;
				}
			}
			for(j=0;j<3;j++) {
				if(i[j] != 0) {
					pc_delitem(sd,i[j],item_amount[j],0);		// ACe
				}
			}
		}

		if(sp) {					// SP
			sd->status.sp-=sp;
			clif_updatestatus(sd,SP_SP);
		}
		if(zeny) {					// Zeny
			sd->status.zeny -= zeny;
			clif_updatestatus(sd,SP_ZENY);
		}
		if(spiritball)				// 
			pc_delspiritball(sd,spiritball,0);
	}
	return 1;
}


/*==========================================
 * rԌvZ
 *------------------------------------------
 */
int skill_castfix( struct block_list *bl, int time )
{
	struct status_change *sc_data;
	int dex=battle_get_dex(bl);
	int castrate=100;
	if(time==0)
		return 0;
	if(bl->type==BL_PC)
		castrate=((struct map_session_data *)bl)->castrate;
	
	time=time*castrate*(150- dex)/15000;
	time=time*battle_config.cast_rate/100;
	
	if( (sc_data = battle_get_sc_data(bl))[SC_SUFFRAGIUM].timer!=-1 ){
		/* TtME */
		time=time*(100-sc_data[SC_SUFFRAGIUM].val1*15)/100;
		skill_status_change_end( bl, SC_SUFFRAGIUM, -1);
	}
	return (time>0)?time:0;
}
/*==========================================
 * fBCvZ
 *------------------------------------------
 */
int skill_delayfix( struct block_list *bl, int time )
{
	if(time<=0)
		return 0;
	
	if( battle_config.delay_dependon_dex )	/* dex̉evZ */
		time=time*(150- battle_get_dex(bl))/150;

	time=time*battle_config.delay_rate/100;
	
	return (time>0)?time:0;
}
/*==========================================
 * XLgpiIDwj
 *------------------------------------------
 */
int skill_use_id( struct map_session_data *sd, int target_id,
	int skill_num, int skill_lv)
{
	int casttime=0,delay=0,tick;
	struct map_session_data* target_sd=NULL;
	int target_fd=-1;
	int forcecast=0;
	struct block_list *bl;
	tick=gettick();

	bl=map_id2bl(target_id);
	if(bl==NULL){
/*		printf("skill target not found %d\n",target_id); */
		return 0;
	}
	if(sd->bl.m != bl->m || pc_isdead(sd))
		return 0;

	/* قُiAOȂǂ̔j */
	if( sd->opt1>0 || sd->status.option&6 || sd->sc_data[SC_DIVINA].timer!=-1 ){
		if( (sd->status.option&4) && skill_num==AS_CLOAKING );	/* N[LO */
		else if( (sd->status.option&2) && (skill_num==TF_HIDING || skill_num==AS_GRIMTOOTH || skill_num==RG_BACKSTAP || skill_num==RG_RAID ));	/* nCfBO */
		else
			return 0;
	}

	if( skill_num==HT_BLITZBEAT && !(sd->status.option&0x10) ){	/* 邪Ȃ */
		return 0;
	}

	/* ˒ƏQ`FbN */
	if(!battle_check_range(&sd->bl,bl->x,bl->y,skill_get_range(skill_num)))
		return 0;

	if(bl->type==BL_PC){
		target_sd=(struct map_session_data*)bl;
		target_fd=target_sd->fd;
	}
	if(skill_num != MO_CHAINCOMBO && skill_num != MO_COMBOFINISH)
		pc_stopattack(sd);

	casttime=skill_castfix(&sd->bl, skill_get_cast( skill_num,skill_lv) );
	delay=skill_delayfix(&sd->bl, skill_get_delay( skill_num,skill_lv) );

	sd->state.skillcastcancel=1;

	switch(skill_num){	/* ȏKv */
	case AL_HEAL:	/* q[ */
		if( battle_get_elem_type(bl)==9)
			forcecast=1;	/* q[A^bNȂrGtFNgL */
		break;
	case ALL_RESURRECTION:	/* UNV */
		if( battle_get_elem_type(bl)==9){	/* GAfbhȂ */
			forcecast=1;	/* ^[AfbgƓr */
			casttime=skill_castfix(&sd->bl, skill_get_cast(PR_TURNUNDEAD,skill_lv) );
		}
		break;
	/* rLZȂ */
	case KN_BRANDISHSPEAR:	/* ufBbVXsA */
	case KN_BOWLINGBASH:	/* {EOobV */
	case AC_CHARGEARROW:	/* `[WA[ */
	case RG_STRIPWEAPON:	/* XgbvEG| */
	case RG_STRIPSHIELD:	/* XgbvV[h */
	case RG_STRIPARMOR:	/* XgbvA[}[ */
	case RG_STRIPHELM:	/* Xgbvw */
	case CR_GRANDCROSS:	/* OhNX */
	case MO_CALLSPIRITS:	// C
	case MO_INVESTIGATE:	/*  */
	case MO_STEELBODY:	/* */
		sd->state.skillcastcancel=0;
		break;
	case MO_FINGEROFFENSIVE:	/* we */
		casttime += casttime * ((skill_lv > sd->spiritball)? sd->spiritball:skill_lv);
		sd->state.skillcastcancel=0;
		break;
	case MO_CHAINCOMBO:		/*Aŏ*/
		sd->state.skillcastcancel=0;
		target_id = sd->attacktarget;
		break;
	case MO_COMBOFINISH:		/*җ*/
		sd->state.skillcastcancel=0;
		target_id = sd->attacktarget;
		break;
	case MO_EXTREMITYFIST:	/*CeP*/
		if(sd->combo_delay3 <= tick && tick <= sd->combo_delay3 + battle_config.asuradelay) {
			casttime = 0;
		}
		break;	
	}

	printf("PC %d skill use target_id=%d skill=%d lv=%d cast=%d\n"
		,sd->bl.id,target_id,skill_num,skill_lv,casttime);

	if(sd->skillitem == skill_num)
		casttime = delay = 0;

	if( casttime>0 || forcecast ){ /* rKv */
		struct mob_data *md;
		clif_skillcasting( &sd->bl,
			sd->bl.id, target_id, 0,0, skill_num,casttime);

		/* rX^[ */
		if( bl->type==BL_MOB && mob_db[(md=(struct mob_data *)bl)->class].mode&0x10 &&
			md->state.state!=MS_ATTACK && sd->ghost_timer == -1){
				md->target_id=sd->bl.id;
				md->state.targettype = ATTACKABLE;
				md->min_chase=13;
		}
	}

	if( casttime<=0 )	/* r̖̂̓LZȂ */
		sd->state.skillcastcancel=0;

	sd->skilltarget	= target_id;
/*	sd->cast_target_bl	= bl; */
	sd->skillx		= 0;
	sd->skilly		= 0;
	sd->skillid		= skill_num;
	sd->skilllv		= skill_lv;
	sd->canact_tick = tick + casttime + delay;
	sd->canmove_tick = tick;
	if(casttime > 0)
		sd->skilltimer = add_timer( tick+casttime, skill_castend_id, sd->bl.id, 0 );
	else {
		sd->skilltimer = -1;
		skill_castend_id(sd->skilltimer,tick,sd->bl.id,0);
	}

	return 0;
}

/*==========================================
 * XLgpiꏊwj
 *------------------------------------------
 */
int skill_use_pos( struct map_session_data *sd,
	int skill_x, int skill_y, int skill_num, int skill_lv)
{
	int casttime=0,delay=0,tick;
	
	if(pc_isdead(sd))
		return 0;

	if( sd->opt1>0 || sd->status.option&6 || sd->sc_data[SC_DIVINA].timer!=-1 )
		return 0;	/* ُⒾقȂ */

	/* ˒ƏQ`FbN */
	if(!battle_check_range(&sd->bl,skill_x,skill_y,skill_get_range(skill_num)))
		return 0;
	
	pc_stopattack(sd);

	casttime=skill_castfix(&sd->bl, skill_get_cast( skill_num,skill_lv) );
	delay=skill_delayfix(&sd->bl, skill_get_delay( skill_num,skill_lv) );

	sd->state.skillcastcancel=1;

	printf("PC %d skill use target_pos=(%d,%d) skill=%d lv=%d cast=%d\n"
		,sd->bl.id,skill_x,skill_y,skill_num,skill_lv,casttime);

	if(sd->skillitem == skill_num)
		casttime = delay = 0;

	if( casttime>0 )	/* rKv */
		clif_skillcasting( &sd->bl,
			sd->bl.id, 0, skill_x,skill_y, skill_num,casttime);

	if( casttime<=0 )	/* r̖̂̓LZȂ */
		sd->state.skillcastcancel=0;

	sd->skillx			= skill_x;
	sd->skilly			= skill_y;
	sd->skilltarget	= 0;
/*	sd->cast_target_bl	= NULL; */
	sd->skillid		= skill_num;
	sd->skilllv			= skill_lv;
	tick=gettick();
	sd->canact_tick = tick + casttime + delay;
	sd->canmove_tick = tick;
	if(casttime > 0)
		sd->skilltimer = add_timer( tick+casttime, skill_castend_pos, sd->bl.id, 0 );
	else {
		sd->skilltimer = -1;
		skill_castend_pos(sd->skilltimer,tick,sd->bl.id,0);
	}

	return 0;
}



/*==========================================
 * XLrLZ
 *------------------------------------------
 */
int skill_castcancel( struct block_list *bl )
{
	if(bl->type==BL_PC){
		struct map_session_data *sd=(struct map_session_data *)bl;
		unsigned long tick=gettick();
		sd->canact_tick=tick;
		sd->canmove_tick = tick;
		if( sd->skilltimer!=-1){
			if( skill_get_inf( sd->skillid )&2 )
				delete_timer( sd->skilltimer, skill_castend_pos );
			else
				delete_timer( sd->skilltimer, skill_castend_id );
			sd->skilltimer=-1;
			clif_skillcastcancel(bl);
		}

		return 0;
	}else if(bl->type==BL_MOB){
		struct mob_data *md=(struct mob_data *)bl;
		if( md->skilltimer!=-1 ){
			if( skill_get_inf( md->skillid )&2 )
				delete_timer( md->skilltimer, mobskill_castend_pos );
			else
				delete_timer( md->skilltimer, mobskill_castend_id );
			md->skilltimer=-1;
			clif_skillcastcancel(bl);
		}
		return 0;
	}
	return 1;
}




/*----------------------------------------------------------------------------
 * Xe[^Xُ
 *----------------------------------------------------------------------------
 */

/*==========================================
 * Xe[^Xُ^C}[͈͏
 *------------------------------------------
 */
int skill_status_change_timer_sub(struct block_list *bl, va_list ap )
{
	struct block_list *src;
	int type;
	unsigned int tick;
	src=va_arg(ap,struct block_list*);
	type=va_arg(ap,int);
	tick=va_arg(ap,unsigned int);
	
	if(bl->type!=BL_PC && bl->type!=BL_MOB)
		return 0;
	
	switch( type ){
	case SC_SIGHT:	/* TCg */
	case SC_RUWACH:	/* At */
		if( (*battle_get_option(bl))&6 ){
			skill_status_change_end( bl, SC_HIDDING, -1);
			skill_status_change_end( bl, SC_CLOAKING, -1);
			if( type==SC_RUWACH && battle_check_target( src,bl, BCT_ENEMY ) > 0)
				skill_attack(BF_MAGIC,src,src,bl,(type==SC_SIGHT)?10:24,1,tick,0);
		}

		break;
	}
	return 0;
}

/*==========================================
 * Xe[^XُI
 *------------------------------------------
 */
int skill_status_change_end( struct block_list* bl , int type,int tid )
{
	struct status_change* sc_data;
	int opt_flag=0;
	short *sc_count, *option, *opt1, *opt2;
	
	sc_data=battle_get_sc_data(bl);
	sc_count=battle_get_sc_count(bl);
	option=battle_get_option(bl);
	opt1=battle_get_opt1(bl);
	opt2=battle_get_opt2(bl);
	
	if(bl->type!=BL_PC && bl->type!=BL_MOB) {
		printf("skill_status_change_end: neither MOB nor PC !\n");
		return 0;
	}
	
	
	if((*sc_count)>0 && sc_data[type].timer!=-1 &&
		(sc_data[type].timer==tid || tid==-1) ){
		
		if(tid==-1)	/* ^C}Ă΂ĂȂȂ^C}폜 */
			delete_timer(sc_data[type].timer,skill_status_change_timer);
	
		/* Ÿُ𐳏ɖ߂ */
		sc_data[type].timer=-1;
		(*sc_count)--;

		if(bl->type==BL_PC && (type<64 || type == SC_EXPLOSIONSPIRITS || type == SC_STEELBODY))	/* ACR */
			clif_status_change(bl,type,0);

		switch(type){	/* ɖ߂ƂȂɂKv */
		case SC_STONE:
		case SC_FREEZE:
		case SC_STAN:
		case SC_SLEEP:
			*opt1=0;
			opt_flag=1;
			break;

		case SC_POISON:
		case SC_CURSE:
		case SC_SILENCE:
		case SC_BLIND:
			*opt2&=~(1<<(type-SC_POISON));
			opt_flag=1;
			break;

		case SC_HIDDING:
		case SC_CLOAKING:
			*option&=~((type==SC_HIDDING)?2:4);
			opt_flag =1 ;
			break;

		case SC_SIGHT:
		case SC_RUWACH:
			*option&=~1;
			opt_flag=1;
			break;
		}
		
		if(opt_flag)	/* option̕ύX` */
			clif_changeoption(bl);

		if(bl->type==BL_PC)
			pc_calcstatus((struct map_session_data *)bl,0);	/* Xe[^XČvZ */
	}

	return 0;
}
/*==========================================
 * Xe[^XُI^C}[
 *------------------------------------------
 */
int skill_status_change_timer(int tid, unsigned int tick, int id, int data)
{
	int type=data;
	struct block_list *bl;
	struct map_session_data *sd=NULL;
	struct status_change *sc_data;
	short *sc_count;
	
	bl=map_id2bl(id);
	if(bl==NULL)
		return 0;
	
	if(bl->type==BL_PC)
		sd=(struct map_session_data *)bl;

	sc_data=battle_get_sc_data(bl);
	sc_count=battle_get_sc_count(bl);
	
	switch(type){	/* ȏɂȂꍇ */
	case SC_MAXIMIZEPOWER:	/* }LV}CYp[ */
	case SC_CLOAKING:		/* N[LO */
		if(sd){
			if( sd->status.sp > 0 ){	/* SP؂܂Ŏ */
				sd->status.sp--;
				clif_updatestatus(sd,SP_SP);
				sc_data[type].timer=add_timer(	/* ^C}[Đݒ */
					sc_data[type].val2+tick, skill_status_change_timer,
					bl->id, data);
				return 0;
			}
		}
		break;

	case SC_HIDDING:		/* nCfBO */
		if(sd){		/* SPāAԐ̊Ԃ͎ */
			if( sd->status.sp > 0 && (--sc_data[type].val2)>0 ){
				if(sc_data[type].val2 % (sc_data[type].val1+3) ==0 ){
					sd->status.sp--;
					clif_updatestatus(sd,SP_SP);
				}
				sc_data[type].timer=add_timer(	/* ^C}[Đݒ */
					1000+tick, skill_status_change_timer,
					bl->id, data);
				return 0;
			}
		}
		break;

	case SC_SIGHT:	/* TCg */
	case SC_RUWACH:	/* At */
		{
			const int range=AREA_SIZE;
			map_foreachinarea( skill_status_change_timer_sub,
				bl->m, bl->x-range, bl->y-range, bl->x+range,bl->y+range,0,
				bl,type,tick);
	
			if( (--sc_data[type].val2)>0 ){
				sc_data[type].timer=add_timer(	/* ^C}[Đݒ */
					250+tick, skill_status_change_timer,
					bl->id, data);
				return 0;
			}
		}
		break;

	case SC_PROVOKE:	/* v{bN/I[go[T[N */
		if(sc_data[type].val2!=0){	/* I[go[T[NiPbƂHP`FbNj */
			if(sd!=NULL && sd->status.hp>sd->status.max_hp/4)	/* ~ */
				break;
			if(sc_data[type].timer==tid)
				sc_data[type].timer=add_timer( 1000+tick,
					skill_status_change_timer, bl->id, data );
		}
		break;

	case SC_WATERBALL:	/* EH[^[{[ */
		{
			struct block_list *target=map_id2bl(sc_data[type].val2);
			if(target==NULL || target->prev==NULL)
				break;
			skill_attack(BF_MAGIC,bl,bl,target,86,sc_data[type].val1,tick,0);
			if((--sc_data[type].val3)>0)
				sc_data[type].timer=add_timer( 100+tick,
					skill_status_change_timer, bl->id, data );
		}
		break;

	/* Ԑ؂ꖳHH */
	case SC_AETERNA:
	case SC_TRICKDEAD:
	case SC_STONE:
/*	case SC_BLIND: */
	case SC_RIDING:
	case SC_FALCON:
	case SC_WEIGHT50:
	case SC_WEIGHT90:
		if(sc_data[type].timer==tid)
			sc_data[type].timer=add_timer( 1000*600+tick,
				skill_status_change_timer, bl->id, data );
		return 0;
	}

	return skill_status_change_end( bl,type,tid );
}
/*==========================================
 * Xe[^XُJn
 *------------------------------------------
 */
int skill_status_change_start(struct block_list *bl,int type,int val1,int val2)
{
	struct map_session_data *sd = NULL;
	struct mob_data *md = NULL;
	struct status_change* sc_data;
	int tick = 0;
	short *sc_count, *option, *opt1, *opt2;
	int opt_flag = 0;
	int val3=0,val4=val2;
	
	sc_data=battle_get_sc_data(bl);
	sc_count=battle_get_sc_count(bl);
	option=battle_get_option(bl);
	opt1=battle_get_opt1(bl);
	opt2=battle_get_opt2(bl);
	
	
	if(bl->type==BL_MOB){
		md=(struct mob_data *)bl;
		if(mob_db[md->class].mode & 0x20 &&
			(type==SC_STONE || type==SC_FREEZE || type==SC_STAN || type==SC_SLEEP)){
			/* {Xɂ͌Ȃ */
			return 0;
		}
	}else if(bl->type==BL_PC){
		sd=(struct map_session_data *)bl;

		if(SC_STONE<=type && type<=SC_BLIND){	/* J[hɂϐ */
			if(sd->reseff[type-SC_STONE] && rand()%100<sd->reseff[type-SC_STONE]){
				printf("PC %d skill_sc_start: cardɂُϐ\n",sd->bl.id);
				return 0;
			}
		}
	}else{
		printf("skill_status_change_start: neither MOB nor PC !\n");
		return 0;
	}
	if(type==SC_STONE || type==SC_FREEZE || type==SC_STAN || type==SC_SLEEP)
		battle_stopwalking(bl,1);

	if(sc_data[type].timer != -1){	/* łɓُɂȂĂꍇ^C} */
		(*sc_count)--;
		delete_timer(sc_data[type].timer, skill_status_change_timer);
		sc_data[type].timer = -1;
	}
	
	switch(type){	/* ُ̎ނƂ̏ */
		case SC_PROVOKE:			/* v{bN */
			if(val2==0)	tick = 1000 * 30;
			else		tick = 1000;/* (I[go[T[N) */
			break;
		case SC_ENDURE:				/* CfA */
			tick = 1000 * (7 + val1*3);
			break;
		case SC_CONCENTRATE:		/* W͌ */
			tick = 1000 * (40 + val1 * 20);
			break;
		case SC_BLESSING:			/* ubVO */
			tick = 1000 * (40 + val1 * 20);
			break;
		case SC_ANGELUS:			/* A[X */
			tick = 1000 * (30 * val1);
			break;
		case SC_INCREASEAGI:		/* x㏸ */
			tick = 1000 * (40 + val1 * 20);
			break;
		case SC_DECREASEAGI:		/* x */
			tick = 1000 * (30 + val1 * 10);
			break;
		case SC_TWOHANDQUICKEN:		/* 2HQ */
			tick = 1000 * (30 * val1);
			break;
		case SC_ADRENALINE:			/* AhibV */
			tick = 1000 * (30 * val1);
			break;
		case SC_WEAPONPERFECTION:	/* EF|p[tFNV */
			tick = 1000 * (30 * val1);
			break;
		case SC_OVERTHRUST:			/* I[o[XXg */
			tick = 1000 * (20 * val1);
			break;
		case SC_MAXIMIZEPOWER:		/* }LV}CYp[(SP1鎞,val2ɂ) */
			tick = 1000 * val1;
			val2 = tick;
			break;
		case SC_ENCPOISON:			/* G`g|CY */
			tick = 1000 * (15 + val1 * 15);
			val2=((val1 - 1) / 2) + 3;	/* ŕt^m */
			if( sc_data[SC_ASPERSIO].timer!=-1 )	/* AXy */
				skill_status_change_end(bl,SC_ASPERSIO,-1);
			break;
		case SC_IMPOSITIO:			/* C|VeBI}kX */
			tick = 1000 * 60;
			break;
		case SC_SUFFRAGIUM:			/* TtM */
			tick = 1000 * (40 - val1 * 10);
			break;
		case SC_ASPERSIO:			/* AXyVI */
			tick = 1000 * (30 + val1 * 30);
			if( sc_data[SC_ENCPOISON].timer!=-1 )	/* EP */
				skill_status_change_end(bl,SC_ENCPOISON,-1);
			break;
		case SC_BENEDICTIO:			/*  */
			tick = 1000 * 40 * val1;
			break;
		case SC_KYRIE:				/* LGGC\ */
			tick = 1000 * 120;
			val2 = ((sd)?sd->status.max_hp:mob_db[md->class].max_hp) *
				 (val1 * 2 + 10) / 100;/* ϋvx */
			val1 = (val1 / 2 + 5);	/*  */
			break;
		case SC_MAGNIFICAT:			/* }OjtBJ[g */
			tick = 1000 * 20 * val1;
			break;
		case SC_GLORIA:				/* OA */
			tick = 1000 * (5 + val1 * 5);
			break;
		case SC_AETERNA:			/* G[ei */
			tick = 1000 * 600;		/* Ƃ肠10ɂĂ݂i̓^C}ŉj */
			break;
		case SC_ENERGYCOAT:			/* GiW[R[g */
			tick = 1000 * 6 * 50;
			break;
		case SC_LOUD:				/* Eh{CX */
			tick = 1000 * 60 * 5;
			break;
		case SC_TRICKDEAD:			/* 񂾂ӂ */
			tick = 1000 * 600;		/* Ƃ肠10ɂĂ݂i̓^C}ŉj */
			break;
		case SC_QUAGMIRE:			/* N@O}CA */
			tick = 5000 * val1;
			break;
		case SC_SIGNUMCRUCIS:		/* VOiNVX */
			tick = 5000 * 60 * 25;
			break;
		case SC_FLAMELAUNCHER:		/* t[`[ */
			tick = 1000 * (15 + val1 * 15);
			break;
		case SC_FROSTWEAPON:		/* tXgEF| */
			tick = 1000 * (15 + val1 * 15);
			break;
		case SC_LIGHTNINGLOADER:	/* CgjO[_[ */
			tick = 1000 * (15 + val1 * 15);
			break;
		case SC_SEISMICWEAPON:		/* TCY~bNEF| */
			tick = 1000 * (15 + val1 * 15);
			break;
		case SC_PROVIDENCE:			/* vBfX */
			tick = 1000 * 180;
			val2=val1*5;
			break;
		case SC_DEFENDER:			/* fBtF_[ */
			tick = 1000 * 180;
			val2=val1*15+5;
			break;
		case SC_SPEARSQUICKEN:		/* XsANCbP */
			tick = 1000 * 300;
			val2=80-val1;
			break;
		case SC_ASSNCROS:			/* [z̃ATVNX */
			tick = 1000 * 120;
			val2=90-val1;
			break;
		case SC_WHISTLE:			/* J */
			tick = 1000 * 60;
			break;
		case SC_APPLEIDUN:			/* ChD̗ь */
			tick = 1000 * 60 * 3;
			val2 = val1*2+5;
			break;
		case SC_SERVICE4U:			/* T[rXtH[[ */
			tick = 1000 * 60 * 3;
			val2 = val1+10;
			break;
		case SC_HUMMING:			/* n~O */
			tick = 1000 * 60;
			val2 = val1*2;
			break;
		case SC_DONTFORGETME:		/* YȂ */
			tick = 1000 * 180;
			val2 = 100+val1*3;
			val3 = 100+val1*2;
			break;
		case SC_FORTUNE:			/* K^̃LX */
			tick = 1000 * 60 * 2;
			break;
		case SC_DRUMBATTLE:			/* 푾ۂ̋ */
			tick = 1000 * 60;
			val2 = (val1+1)*25;
			val3 = (val1+1)*2;
			break;
		case SC_ETERNALCHAOS:		/* G^[iJIX */
			tick = 1000* 60;
			break;
		case SC_NIBELUNGEN:			/* j[xO̎w */
			tick = 1000 * 60;
			val2 = (val1+2)*50;
			break;
		case SC_SIEGFRIED:			/* sg̃W[Nt[h */
			tick = 1000 * 60;
			val2 = (val1+3)*10;
			break;
		case SC_EXPLOSIONSPIRITS:	// g
			tick = 1000 * 60 * 3;
			val2 = 75 + 25*val1;
			break;
		case SC_STEELBODY:			// 
			tick = 1000 * 30 * val1;
			break;

		/* option1 */
		case SC_SPEEDPOTION0:		/* |[V */
		case SC_SPEEDPOTION1:
		case SC_SPEEDPOTION2:
			tick = 1000 * val1;
			val2 = 100- 5*(2+type-SC_SPEEDPOTION0);
			break;

		case SC_STONE:				/* Ή */
			if( (tick=val2)<=0 )
				tick = 1000 * 600;		/* Ƃ肠10ɂĂ݂i̓^C}ŉj */
			break;
		case SC_SLEEP:				/*  */
			tick = val2;
			break;
		case SC_FREEZE:				/*  */
			if( (tick=val2)<=0 )
				tick = 1000 * 3 * val1;
			break;
		case SC_STAN:				/* X^ival2Ƀ~bZbgj */
			tick = val2;
			break;

		/* option2 */
		case SC_POISON:				/*  */
			if( (tick=val2)<=0 )
				tick = 1000 * (10 + rand()%50);	/* KȒ */
			break;
		case SC_SILENCE:			/* فibNXfr[ij */
			if( (tick=val2)<=0 )
				tick = 1000 * ( (val1>6)?60: 25 + val1 * 5);
			break;
		case SC_BLIND:				/* Í */
			if( (tick=val2)<=0 )
				tick = 500*600;		/* Ƃ肠T */
			break;
			
		/* option */
		case SC_HIDDING:		/* nCfBO */
			tick = 1000;			/* Pbԃ`FbN */
			val2 = 30 * val1;		/*  */
			break;
		case SC_CLOAKING:		/* N[LO */
			tick = 1000 * (3 + val1 );	/* SP1鎞(val2ɂZbg) */
			val2 = tick;
			break;
		case SC_SIGHT:			/* TCg/At */
		case SC_RUWACH:
			tick=10;
			val2=40;	/* 250*40=10b */
			break;

		/* Z[teBEH[Aj[} */
		case SC_SAFETYWALL:	case SC_PNEUMA:
			tick=((struct skill_unit *)val2)->group->limit;
			break;

		/* AN */
		case SC_ANKLE:
			tick=val2;
			break;

		/* EH[^[{[ */
		case SC_WATERBALL:
			tick=100;
			val3= (val1|1)*(val1|1)-1;
			break;

		/* XLȂ/ԂɊ֌WȂ */
		case SC_RIDING:	case SC_FALCON:	case SC_WEIGHT50:	case SC_WEIGHT90:
			tick=600*1000;
			break;

		default:
			printf("UnknownStatusChange [%d]\n", type);
			return 0;
	}

	if(bl->type==BL_PC && (type<64 || type == SC_EXPLOSIONSPIRITS || type == SC_STEELBODY))	/* ACR\pPbg */
		clif_status_change(bl,type,1);

	/* option̕ύX */
	switch(type){
		case SC_STONE:	case SC_FREEZE:	case SC_STAN:	case SC_SLEEP:
			battle_stopattack(bl);	/* U~ */
			{
				/* Ɋ|ȂXe[^Xُ */
				int i;
				for(i = SC_STONE; i <= SC_SLEEP; i++){
					if(sc_data[i].timer != -1){
						(*sc_count)--;
						delete_timer(sc_data[i].timer, skill_status_change_timer);
						sc_data[i].timer = -1;
					}
				}
			}
			*opt1 = type - SC_STONE + 1;
			opt_flag = 1;
			break;
		case SC_POISON:	case SC_CURSE:	case SC_SILENCE:	case SC_BLIND:
			*opt2|= 1<<(type-SC_POISON);
			opt_flag = 1;
			break;
		case SC_HIDDING:	case SC_CLOAKING:
			battle_stopattack(bl);	/* U~ */
			*option|= ((type==SC_HIDDING)?2:4);
			opt_flag =1 ;
			break;
		case SC_SIGHT:	case SC_RUWACH:
			*option|=1;
			opt_flag=1;
			break;
	}

	if(opt_flag)	/* option̕ύX */
		clif_changeoption(bl);

	(*sc_count)++;	/* Xe[^Xُ̐ */

	sc_data[type].val1 = val1;
	sc_data[type].val2 = val2;
	sc_data[type].val3 = val3;
	sc_data[type].val4 = val4;
	/* ^C}[ݒ */
	sc_data[type].timer = add_timer(
		gettick() + tick, skill_status_change_timer, bl->id, type);

	if(bl->type==BL_PC)
		pc_calcstatus(sd,0);	/* Xe[^XČvZ */

	return 0;
}
/*==========================================
 * Xe[^XُS
 *------------------------------------------
 */
int skill_status_change_clear(struct block_list *bl)
{
	struct status_change* sc_data;
	short *sc_count, *option, *opt1, *opt2;
	int i;
	
	sc_data=battle_get_sc_data(bl);
	sc_count=battle_get_sc_count(bl);
	option=battle_get_option(bl);
	opt1=battle_get_opt1(bl);
	opt2=battle_get_opt2(bl);
	
	if(*sc_count == 0)
		return 0;
	for(i = 0; i < MAX_STATUSCHANGE; i++){
		if(sc_data[i].timer != -1){	/* ُ킪Ȃ^C}[폜 */
			delete_timer(sc_data[i].timer, skill_status_change_timer);
			sc_data[i].timer = -1;
			if(bl->type==BL_PC && (i<64 || i == SC_EXPLOSIONSPIRITS || i == SC_STEELBODY))	/* ACR */
				clif_status_change(bl,i,0);
		}
	}
	*sc_count = 0;
	*opt1 = 0;
	*opt2 = 0;
	*option &= 0xfff8;

	if( bl->type==BL_PC )
		clif_changeoption(bl);

	return 0;
}


/* N[LOiɈړs\nт邩j */
int skill_check_cloaking(struct block_list *bl)
{
	static int dx[]={-1, 0, 1,-1, 1,-1, 0, 1};
	static int dy[]={-1,-1,-1, 0, 0, 1, 1, 1};
	int end=1,i;
	for(i=0;i<sizeof(dx)/sizeof(dx[0]);i++){
		int c=map_getcell(bl->m,bl->x+dx[i],bl->y+dy[i]);
		if(c==1 || c==5) end=0;
	}
	if(end){
		skill_status_change_end(bl, SC_CLOAKING, -1);
		*battle_get_option(bl)&=~4;	/* Ô߂̏ */
	}
	return end;
}





/*
 *----------------------------------------------------------------------------
 * XLjbg
 *----------------------------------------------------------------------------
 */


/*==========================================
 * XLjbg
 *------------------------------------------
 */
struct skill_unit *skill_initunit(struct skill_unit_group *group,int idx,int x,int y)
{
	struct skill_unit *unit=&group->unit[idx];
	
	if(!unit->alive)
		group->alive_count++;
	
	unit->bl.id=map_addobject(&unit->bl);
	unit->bl.type=BL_SKILL;
	unit->bl.m=group->map;
	unit->bl.x=x;
	unit->bl.y=y;
	unit->group=group;
	unit->val1=unit->val2=0;
	unit->alive=1;

	map_addblock(&unit->bl);
	clif_skill_setunit(unit);
	return unit;
}

int skill_unit_timer_sub_ondelete( struct block_list *bl, va_list ap );
/*==========================================
 * XLjbg폜
 *------------------------------------------
 */
int skill_delunit(struct skill_unit *unit)
{
	struct skill_unit_group *group=unit->group;
	int range;
/*	printf("delunit %d\n",unit->bl.id); */

	if(!unit->alive || group==NULL)
		return 0;

	/* onlimitCxgĂяo */
	skill_unit_onlimit( unit,gettick() );

	/* ondeleteCxgĂяo */
	range=unit->group->range;
	map_foreachinarea( skill_unit_timer_sub_ondelete, unit->bl.m,
		unit->bl.x-range,unit->bl.y-range,unit->bl.x+range,unit->bl.y+range,0,
		&unit->bl,gettick() );

	clif_skill_delunit(unit);
	
	
	unit->group=NULL;
	unit->alive=0;
	map_delobjectnofree(unit->bl.id);
	if(group->alive_count>0 && (--group->alive_count)<=0)
		skill_delunitgroup(group);
	
	return 0;
}
/*==========================================
 * XLjbgO[v
 *------------------------------------------
 */
static int skill_unit_group_newid=10;
struct skill_unit_group *skill_initunitgroup(struct block_list *src,
	int count,int skillid,int skilllv,int unit_id)
{
	int i;
	struct skill_unit_group *group=NULL, *list=NULL;
	int maxsug=0;

	if(src->type==BL_PC){
		list=((struct map_session_data *)src)->skillunit;
		maxsug=MAX_SKILLUNITGROUP;
	}else if(src->type==BL_MOB){
		list=((struct mob_data *)src)->skillunit;
		maxsug=MAX_MOBSKILLUNITGROUP;
	}
	if(list){
		for(i=0;i<maxsug;i++)	/* 󂢂Ă̌ */
			if(list[i].group_id==0){
				group=&list[i];
				break;
			}

		if(group==NULL){	/* 󂢂ĂȂ̂ŌÂ̌ */
			int j=0;
			unsigned maxdiff=0,x,tick=gettick();
			for(i=0;i<maxsug;i++)
				if((x=DIFF_TICK(tick,list[i].tick))>maxdiff){
					maxdiff=x;
					j=i;
				}
			skill_delunitgroup(&list[j]);
			group=&list[j];
		}
	}

	if(group==NULL){
		printf("skill_initunitgroup: error unit group !\n");
		exit(0);
	}

	group->src_id=src->id;
	group->party_id=battle_get_party_id(src);
	group->guild_id=battle_get_guild_id(src);
	group->group_id=skill_unit_group_newid++;
	if(skill_unit_group_newid<=0)
		skill_unit_group_newid=10;

	group->unit=malloc(sizeof(struct skill_unit)*count);
	if(group->unit==NULL){
		printf("skill_initunitgroup: out of memory! \n");
		exit(0);
	}
	memset(group->unit,0,sizeof(struct skill_unit)*count);

	group->unit_count=count;
	group->val1=group->val2=0;
	group->skill_id=skillid;
	group->skill_lv=skilllv;
	group->unit_id=unit_id;
	group->map=src->m;
	group->range=0;
	group->limit=10000;
	group->interval=1000;
	group->tick=gettick();
	memset(group->vallist,0,sizeof(group->vallist));
	group->valstr=NULL;

	return group;
}


/*==========================================
 * XLjbgO[v폜
 *------------------------------------------
 */
int skill_delunitgroup(struct skill_unit_group *group)
{
	int i;
	if(group->unit_count<=0)
		return 0;

/*	printf("delunitgroup %d\n",group->group_id); */

	group->alive_count=0;
	if(group->unit!=NULL){
		for(i=0;i<group->unit_count;i++)
			if(group->unit[i].alive)
				skill_delunit(&group->unit[i]);
	}
	if(group->valstr!=NULL){
		map_freeblock(group->valstr);
		group->valstr=NULL;
	}
	
	map_freeblock(group->unit);	/* free()̑ւ */
	group->unit=NULL;
	group->src_id=0;
	group->group_id=0;
	group->unit_count=0;
	return 0;
}


/*==========================================
 * XLjbgO[vS폜
 *------------------------------------------
 */
int skill_clear_unitgroup(struct block_list *src)
{
	struct skill_unit_group *group=NULL;
	int maxsug=0;
	if(src->type==BL_PC){
		group=((struct map_session_data *)src)->skillunit;
		maxsug=MAX_SKILLUNITGROUP;
	}else if(src->type==BL_MOB){
		group=((struct mob_data *)src)->skillunit;
		maxsug=MAX_MOBSKILLUNITGROUP;
	}
	if(group){
		int i;
		for(i=0;i<maxsug;i++)
			if(group[i].group_id>0)
				skill_delunitgroup(&group[i]);
	}
	return 0;
}


/*==========================================
 * XLjbgO[v̔etick
 *------------------------------------------
 */
struct skill_unit_group_tickset *skill_unitgrouptickset_search(
	struct block_list *bl,int group_id)
{
	int i,j=0,k,s=group_id%MAX_SKILLUNITGROUPTICKSET;
	struct skill_unit_group_tickset *set=NULL;
	if(bl->type==BL_PC){
		set=((struct map_session_data *)bl)->skillunittick;
	}else{
		set=((struct mob_data *)bl)->skillunittick;
	}
	if(set==NULL)
		return 0;
	for(i=0;i<MAX_SKILLUNITGROUPTICKSET;i++)
		if( set[(k=(i+s)%MAX_SKILLUNITGROUPTICKSET)].group_id == group_id )
			return &set[k];
		else if( set[k].group_id==0 )
			j=k;

	return &set[j];
}


/*==========================================
 * XLjbgO[v̔etick폜
 *------------------------------------------
 */
int skill_unitgrouptickset_delete(struct block_list *bl,int group_id)
{
	int i,s=group_id%MAX_SKILLUNITGROUPTICKSET;
	struct skill_unit_group_tickset *set=NULL,*ts;
	if(bl->type==BL_PC){
		set=((struct map_session_data *)bl)->skillunittick;
	}else{
		set=((struct mob_data *)bl)->skillunittick;
	}
	
	if(set!=NULL){
	
		for(i=0;i<MAX_SKILLUNITGROUPTICKSET;i++)
			if( (ts=&set[(i+s)%MAX_SKILLUNITGROUPTICKSET])->group_id == group_id )
				ts->group_id=0;

	}
	return 0;
}


/*==========================================
 * XLjbg^C}[p(foreachinarea)
 *------------------------------------------
 */
int skill_unit_timer_sub_onplace( struct block_list *bl, va_list ap )
{
	struct block_list *src;
	unsigned int tick;
	src=va_arg(ap,struct block_list*);
	tick=va_arg(ap,unsigned int);


	if( ((struct skill_unit *)src)->alive &&
		battle_check_target(src,bl,((struct skill_unit *)src)->group->target_flag )>0 )
			skill_unit_onplace( (struct skill_unit *)src, bl, tick );
	return 0;
}


/*==========================================
 * XLjbg^C}[폜p(foreachinarea)
 *------------------------------------------
 */
int skill_unit_timer_sub_ondelete( struct block_list *bl, va_list ap )
{
	struct block_list *src;
	unsigned int tick;
	src=va_arg(ap,struct block_list*);
	tick=va_arg(ap,unsigned int);

	if( ((struct skill_unit *)src)->alive &&
		battle_check_target(src,bl,((struct skill_unit *)src)->group->target_flag )>0 )
			skill_unit_ondelete( (struct skill_unit *)src, bl, tick );
	return 0;
}


/*==========================================
 * XLjbg^C}[p(foreachobject)
 *------------------------------------------
 */
int skill_unit_timer_sub( struct block_list *bl, va_list ap )
{
	struct skill_unit *unit=(struct skill_unit *)bl;
	struct skill_unit_group *group;
	int range;
	unsigned int tick;
	tick=va_arg(ap,unsigned int);

	if(!unit->alive)
		return 0;

	group=unit->group;
	range=(unit->range!=0)?unit->range:group->range;

	/* onplaceCxgĂяo */
	if(unit->alive && unit->range>=0)
		map_foreachinarea( skill_unit_timer_sub_onplace, bl->m,
			bl->x-range,bl->y-range,bl->x+range,bl->y+range,0,
			bl,tick );

	/* Ԑ؂폜 */
	if(unit->alive &&
		(DIFF_TICK(tick,group->tick)>=group->limit ||
		 DIFF_TICK(tick,group->tick)>=unit->limit) ){
		skill_delunit(unit);
	}

	return 0;
}


/*==========================================
 * XLjbg^C}[
 *------------------------------------------
 */
int skill_unit_timer( int tid,unsigned int tick,int id,int data)
{
	map_freeblock_lock();

	map_foreachobject( skill_unit_timer_sub, BL_SKILL, tick );

	map_freeblock_unlock();
	return 0;
}


/*==========================================
 * XLjbgړp(foreachinarea)
 *------------------------------------------
 */
int skill_unit_move_sub( struct block_list *bl, va_list ap )
{
	struct skill_unit *unit=(struct skill_unit *)bl;
	struct skill_unit_group *group;
	struct block_list *src;
	int range;
	unsigned int tick;
	src=va_arg(ap,struct block_list*);
	tick=va_arg(ap,unsigned int);

	if(!unit->alive || src->prev==NULL)
		return 0;

	group=unit->group;
	range=(unit->range!=0)?unit->range:group->range;

	if( range<0 || battle_check_target(bl,src,group->target_flag )<=0 )
		return 0;

	if( src->x >= bl->x-range && src->x <= bl->x+range &&
		src->y >= bl->y-range && src->y <= bl->y+range )
		skill_unit_onplace( unit, src, tick );
	else
		skill_unit_onout( unit, src, tick );

	return 0;
}


/*==========================================
 * XLjbgړ
 *------------------------------------------
 */
int skill_unit_move( struct block_list *bl,unsigned int tick,int range)
{
	if(bl->prev==NULL)
		return 0;

	if(range<5)
		range=5;
	map_foreachinarea( skill_unit_move_sub,
		bl->m,bl->x-range,bl->y-range,bl->x+range,bl->y+range,BL_SKILL,
		bl,tick );

	return 0;
}


/*----------------------------------------------------------------------------
 * ACe
 *----------------------------------------------------------------------------
 */

/*==========================================
 * ACe\
 *------------------------------------------
 */
int skill_can_produce_mix( struct map_session_data *sd, int nameid, int trigger )
{
	int i,j,equip;

	if(nameid<=0)
		return 0;

	for(i=0;i<MAX_SKILL_PRODUCE_DB;i++){
		if(skill_produce_db[i].nameid == nameid )
			break;
	}
	if( i == MAX_SKILL_PRODUCE_DB )	/* f[^x[XɂȂ */
		return 0;

	if(trigger>=0){
		equip = itemdb_isequip(nameid);
		if(trigger==16){
			if(equip)	/* nzF͂ */
				return 0;
		}else{
			if(!equip)		/* ȁSzn͂ */
				return 0;
			if( itemdb_wlv(nameid) > trigger )	/* Lv */
				return 0;
		}
	}
	if( (j=skill_produce_db[i].req_skill)>0 && pc_checkskill(sd,j)<=0 )
		return 0;		/* XLȂ */

	for(j=0;j<5;j++){
		int id,x,y;
		if( (id=skill_produce_db[i].mat_id[j])==0 )	/* ȏ͍ޗvȂ */
			break;
		for(y=0,x=0;y<MAX_INVENTORY;y++)
			if( sd->status.inventory[y].nameid == id )
				x+=sd->status.inventory[y].amount;
		if(x<skill_produce_db[i].mat_amount[j])	/* ACeȂ */
			return 0;
	}
	return i+1;
}


/*==========================================
 * ACe\
 *------------------------------------------
 */
int skill_produce_mix( struct map_session_data *sd,
	int nameid, int slot1, int slot2, int slot3 )
{
	int slot[3];
	int i,sc,ele,idx,equip,wlv,make_per,flag;

	if( !(idx=skill_can_produce_mix(sd,nameid,-1)) )	/* s */
		return 0;
	idx--;
	slot[0]=slot1;
	slot[1]=slot2;
	slot[2]=slot3;

	/* ߍݏ */
	for(i=0,sc=0,ele=0;i<3;i++){
		int j;
		if( slot[i]<=0 )
			continue;
		j = pc_search_inventory(sd,slot[i]);
		if(j < 0)	/* spPbg(ACe)`FbN */
			continue;
		if(slot[i]==1000){	/* ̂ */
			pc_delitem(sd,j,1,1);
			sc++;
		}
		if(slot[i]>=994 && slot[i]<=997 && ele==0){	/*  */
			static const int ele_table[4]={3,1,4,2};
			pc_delitem(sd,j,1,1);
			ele=ele_table[slot[i]-994];
		}
	}

	/* ޗ */
	for(i=0;i<5;i++){
		int j,id,x;
		if( (id=skill_produce_db[idx].mat_id[i])<=0 )
			break;
		x=skill_produce_db[idx].mat_amount[i];	/* KvȌ */
		do{	/* Qȏ̃CfbNXɂ܂Ă邩Ȃ */
			int y=0;
			j = pc_search_inventory(sd,id);
			
			if(j >= 0){
				y = sd->status.inventory[j].amount;
				if(y>x)y=x;	/* Ă */
				pc_delitem(sd,j,y,0);
			}else
				printf("skill_produce_mix: material item error\n");

			x-=y;	/* ܂ȂvZ */
		}while( j>=0 && x>0 );	/* ޗ邩AG[ɂȂ܂ŌJԂ */
	}

	/* m */
	equip = itemdb_isequip(nameid);
	if(!equip) {
		if(nameid == 998)
			make_per = 2000 + sd->status.base_level*30 + sd->paramc[4]*20 + sd->paramc[5]*10 + pc_checkskill(sd,skill_produce_db[idx].req_skill)*600;
		else if(nameid == 985)
			make_per = 1000 + sd->status.base_level*30 + sd->paramc[4]*20 + sd->paramc[5]*10 + (pc_checkskill(sd,skill_produce_db[idx].req_skill)-1)*500;
		else
			make_per = 1000 + sd->status.base_level*30 + sd->paramc[4]*20 + sd->paramc[5]*10 + pc_checkskill(sd,skill_produce_db[idx].req_skill)*500;
	}
	else {
		int add_per;
		if(pc_search_inventory(sd,989) >= 0) add_per = 750;
		else if(pc_search_inventory(sd,988) >= 0) add_per = 500;
		else if(pc_search_inventory(sd,987) >= 0) add_per = 250;
		else if(pc_search_inventory(sd,986) >= 0) add_per = 0;
		else add_per = -500;
		if(ele) add_per -= 500;
		add_per -= sc*500;
		wlv = itemdb_wlv(nameid);
		make_per = ((250 + sd->status.base_level*15 + sd->paramc[4]*10 + sd->paramc[5]*5 + pc_checkskill(sd,skill_produce_db[idx].req_skill)*500 +
			add_per) * (100 - (wlv - 1)*20))/100 + pc_checkskill(sd,107)*100 + ((wlv >= 3)? pc_checkskill(sd,97)*100 : 0);
	}

	if(make_per < 1) make_per = 1;

	if( battle_config.wp_rate!=100 )	/* m␳ */
		make_per=make_per*battle_config.wp_rate/100;

	/* debug code */
	/*printf("make success percent = %.2lf\n",(double)make_per/100.); */
	
	if(rand()%10000 < make_per){
		/*  */
		struct item tmp_item;
		memset(&tmp_item,0,sizeof(tmp_item));
		tmp_item.nameid=nameid;
		tmp_item.amount=1;
		tmp_item.identify=1;
		if(equip){	/* ̏ꍇ */
			tmp_item.card[0]=0x00ff; /* tO */
			tmp_item.card[1]=((sc*5)<<8)+ele;	/* Ƃ悳 */
			*((unsigned long *)(&tmp_item.card[2]))=sd->char_id;	/* LID */
		}
		clif_produceeffect(sd,0,nameid);/* GtFNgpPbg */
		clif_misceffect(&sd->bl,3); /* lɂʒmiBGtFNgƓł́Hj */
		if((flag = pc_additem(sd,&tmp_item,1))) {
			clif_additem(sd,0,0,flag);
			map_addflooritem(&tmp_item,1,sd->bl.m,sd->bl.x,sd->bl.y);
		}
	}
	else {
		/* s */
		clif_produceeffect(sd,1,nameid);/* GtFNgpPbg */
		clif_misceffect(&sd->bl,2); /* lɂsʒm */
	}
	return 0;
}


/*----------------------------------------------------------------------------
 * n
 */

/*==========================================
 * XL֌Wt@Cǂݍ
 * skill_db.txt XLf[^
 * cast_db.txt XL̉rԂƃfBCf[^
 * produce_db.txt ACe쐬XLpf[^
 * create_arrow_db.txt 쐬XLpf[^
 *------------------------------------------
 */
int skill_readdb(void)
{
	int i,j,k;
	FILE *fp;
	char line[1024],*p;

	/* XLf[^x[X */
	memset(skill_db,0,sizeof(skill_db));
	fp=fopen("db/skill_db.txt","r");
	if(fp==NULL){
		printf("can't read db/skill_db.txt\n");
		return 1;
	}
	while(fgets(line,1020,fp)){
		char *split[50], *split2[16];
		if(line[0]=='/' && line[1]=='/')
			continue;
		for(j=0,p=line;j<10 && p;j++){
			split[j]=p;
			p=strchr(p,',');
			if(p) *p++=0;
		}
		if(split[9]==NULL || j<10)
			continue;

		i=atoi(split[0]);
		if(i<0 || i>MAX_SKILL_DB)
			continue;

/*		printf("skill id=%d\n",i); */
		skill_db[i].range=atoi(split[1]);
		skill_db[i].hit=atoi(split[2]);
		skill_db[i].inf=atoi(split[3]);
		skill_db[i].pl=atoi(split[4]);
		skill_db[i].nk=atoi(split[5]);
		skill_db[i].max=atoi(split[6]);

		memset(split2,0,sizeof(split2));
		for(j=0,p=split[7];j<10 && p;j++){
			split2[j]=p;
			p=strchr(p,':');
			if(p) *p++=0;
		}
		for(k=0;k<10;k++)
			skill_db[i].sp[k]=(split2[k]?atoi(split2[k]):atoi(split2[0]));

		memset(split2,0,sizeof(split2));
		for(j=0,p=split[8];j<10 && p;j++){
			split2[j]=p;
			p=strchr(p,':');
			if(p) *p++=0;
		}
		for(k=0;k<10;k++)
			skill_db[i].num[k]=(split2[k]?atoi(split2[k]):atoi(split2[0]));
		
		skill_db[i].inf2=atoi(split[9]);

	}
	fclose(fp);
	printf("read db/skill_db.txt done\n");

	/* LXeBOf[^x[X */
/*	for(i=0;i<MAX_SKILL;i++){
		for(j=0;j<10;j++){
			skill_db[i].cast[j]=1000;
			skill_db[i].delay[j]=1000;
		}
	}*/
	fp=fopen("db/cast_db.txt","r");
	if(fp==NULL){
		printf("can't read db/cast_db.txt\n");
		return 1;
	}
	while(fgets(line,1020,fp)){
		char *split[50], *split2[16];
		if(line[0]=='/' && line[1]=='/')
			continue;
		for(j=0,p=line;j<3 && p;j++){
			split[j]=p;
			p=strchr(p,',');
			if(p) *p++=0;
		}
		if(split[2]==NULL || j<3)
			continue;

		i=atoi(split[0]);
		if(i<0 || i>MAX_SKILL_DB)
			continue;

		memset(split2,0,sizeof(split2));
		for(j=0,p=split[1];j<10 && p;j++){
			split2[j]=p;
			p=strchr(p,':');
			if(p) *p++=0;
		}
		for(k=0;k<10;k++)
			skill_db[i].cast[k]=(split2[k]?atoi(split2[k]):atoi(split2[0]));

		memset(split2,0,sizeof(split2));
		for(j=0,p=split[2];j<10 && p;j++){
			split2[j]=p;
			p=strchr(p,':');
			if(p) *p++=0;
		}
		for(k=0;k<10;k++)
			skill_db[i].delay[k]=(split2[k]?atoi(split2[k]):atoi(split2[0]));
	}
	fclose(fp);
	printf("read db/cast_db.txt done\n");

	memset(skill_produce_db,0,sizeof(skill_produce_db));
	fp=fopen("db/produce_db.txt","r");
	if(fp==NULL){
		printf("can't read db/produce_db.txt\n");
		return 1;
	}
	k=0;
	while(fgets(line,1020,fp)){
		char *split[16];
		int x,y;
		if(line[0]=='/' && line[1]=='/')
			continue;
		memset(split,0,sizeof(split));
		if(line[0]=='/' && line[1]=='/')
			continue;
		for(j=0,p=line;j<13 && p;j++){
			split[j]=p;
			p=strchr(p,',');
			if(p) *p++=0;
		}
		if(split[0]==NULL)
			continue;
		i=atoi(split[0]);
		if(i<=0)
			continue;

		skill_produce_db[k].nameid=i;
		skill_produce_db[k].req_skill=atoi(split[2]);

		for(x=3,y=0;split[x] && split[x+1] && y<5;x+=2,y++){
			skill_produce_db[k].mat_id[y]=atoi(split[x]);
			skill_produce_db[k].mat_amount[y]=atoi(split[x+1]);
		}
		k++;
		if(k >= MAX_SKILL_PRODUCE_DB)
			break;
	}
	fclose(fp);
	printf("read db/produce_db.txt done (count=%d)\n",k);

	memset(skill_arrow_db,0,sizeof(skill_arrow_db));
	fp=fopen("db/create_arrow_db.txt","r");
	if(fp==NULL){
		printf("can't read db/create_arrow_db.txt\n");
		return 1;
	}
	k=1;
	while(fgets(line,1020,fp)){
		char *split[16];
		int x,y;
		if(line[0]=='/' && line[1]=='/')
			continue;
		memset(split,0,sizeof(split));
		if(line[0]=='/' && line[1]=='/')
			continue;
		for(j=0,p=line;j<13 && p;j++){
			split[j]=p;
			p=strchr(p,',');
			if(p) *p++=0;
		}
		if(split[0]==NULL)
			continue;
		i=atoi(split[0]);
		if(i<=0)
			continue;

		skill_arrow_db[k].nameid=i;

		for(x=1,y=0;split[x] && split[x+1] && y<5;x+=2,y++){
			skill_arrow_db[k].cre_id[y]=atoi(split[x]);
			skill_arrow_db[k].cre_amount[y]=atoi(split[x+1]);
		}
		k++;
		if(k >= MAX_SKILL_ARROW_DB)
			break;
	}
	fclose(fp);
	printf("read db/create_arrow_db.txt done (count=%d)\n",k);

	return 0;
}


/*==========================================
 * XL֌W
 *------------------------------------------
 */
int do_init_skill(void)
{
	skill_readdb();

	add_timer_func_list(skill_unit_timer,"skill_unit_timer");
	add_timer_func_list(skill_castend_id,"skill_castend_id");
	add_timer_func_list(skill_castend_pos,"skill_castend_pos");
	add_timer_func_list(skill_timerskill,"skill_timerskill");
	add_timer_func_list(skill_status_change_timer,"skill_status_change_timer");
	add_timer_interval(gettick()+SKILLUNITTIMER_INVERVAL,skill_unit_timer,0,0,SKILLUNITTIMER_INVERVAL);

	return 0;
}


